<?php
/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'JP_LogisticsInvoiceSummaryBusinessPartnerTypeCode' => '\\StructType\\JP_LogisticsInvoiceSummaryBusinessPartnerTypeCode',
            'ExchangeFaultData' => '\\StructType\\ExchangeFaultData',
            'ExchangeLogData' => '\\StructType\\ExchangeLogData',
            'SelectionByCode' => '\\StructType\\SelectionByCode',
            'SelectionByIdentifier' => '\\StructType\\SelectionByIdentifier',
            'SelectionByIndicator' => '\\StructType\\SelectionByIndicator',
            'SelectionByName' => '\\StructType\\SelectionByName',
            'SelectionByUUID' => '\\StructType\\SelectionByUUID',
            'StandardFaultMessageExtension' => '\\StructType\\StandardFaultMessageExtension',
            'StandardFaultMessage' => '\\StructType\\StandardFaultMessage',
            'CustomerByCommunicationDataQueryMessage_sync' => '\\StructType\\CustomerByCommunicationDataQueryMessage_sync',
            'CustomerByElementsQueryMessage_sync' => '\\StructType\\CustomerByElementsQueryMessage_sync',
            'CustomerByIdentificationQueryMessage_sync' => '\\StructType\\CustomerByIdentificationQueryMessage_sync',
            'CustomerReponseContactPersonResponsibleEmployee' => '\\StructType\\CustomerReponseContactPersonResponsibleEmployee',
            'CustomerReponseCustomer' => '\\StructType\\CustomerReponseCustomer',
            'CustomerReponseCustomerAddress' => '\\StructType\\CustomerReponseCustomerAddress',
            'CustomerReponseCustomerAddressInformation' => '\\StructType\\CustomerReponseCustomerAddressInformation',
            'CustomerReponseCustomerAddressPostalAddress' => '\\StructType\\CustomerReponseCustomerAddressPostalAddress',
            'CustomerReponseCustomerAddressTelephone' => '\\StructType\\CustomerReponseCustomerAddressTelephone',
            'CustomerReponseCustomerAddressUsage' => '\\StructType\\CustomerReponseCustomerAddressUsage',
            'CustomerReponseCustomerBankDetails' => '\\StructType\\CustomerReponseCustomerBankDetails',
            'CustomerReponseCustomerCommunicationArrangement' => '\\StructType\\CustomerReponseCustomerCommunicationArrangement',
            'CustomerReponseCustomerCommunicationArrangementMultiChannel' => '\\StructType\\CustomerReponseCustomerCommunicationArrangementMultiChannel',
            'CustomerReponseCustomerCommunicationChannel' => '\\StructType\\CustomerReponseCustomerCommunicationChannel',
            'CustomerReponseCustomerCommunicationEmail' => '\\StructType\\CustomerReponseCustomerCommunicationEmail',
            'CustomerReponseCustomerContactPerson' => '\\StructType\\CustomerReponseCustomerContactPerson',
            'CustomerReponseCustomerContactPersonAddress' => '\\StructType\\CustomerReponseCustomerContactPersonAddress',
            'CustomerReponseCustomerContactPersonAddressInformation' => '\\StructType\\CustomerReponseCustomerContactPersonAddressInformation',
            'CustomerReponseCustomerContactPersonAddressUsage' => '\\StructType\\CustomerReponseCustomerContactPersonAddressUsage',
            'CustomerReponseCustomerContactPersonTelephone' => '\\StructType\\CustomerReponseCustomerContactPersonTelephone',
            'CustomerReponseCustomerDirectResponsibility' => '\\StructType\\CustomerReponseCustomerDirectResponsibility',
            'CustomerReponseCustomerFormattedAddress' => '\\StructType\\CustomerReponseCustomerFormattedAddress',
            'CustomerReponseCustomerGeneralProductTaxExemption' => '\\StructType\\CustomerReponseCustomerGeneralProductTaxExemption',
            'CustomerReponseCustomerOperatingHoursInformation' => '\\StructType\\CustomerReponseCustomerOperatingHoursInformation',
            'CustomerReponseCustomerOperatingHoursInformationRecurringDayProgramme' => '\\StructType\\CustomerReponseCustomerOperatingHoursInformationRecurringDayProgramme',
            'CustomerReponseCustomerOrganisation' => '\\StructType\\CustomerReponseCustomerOrganisation',
            'CustomerReponseCustomerPaymentCardDetails' => '\\StructType\\CustomerReponseCustomerPaymentCardDetails',
            'CustomerReponseCustomerPaymentData' => '\\StructType\\CustomerReponseCustomerPaymentData',
            'CustomerReponseCustomerPaymentDataPaymentForm' => '\\StructType\\CustomerReponseCustomerPaymentDataPaymentForm',
            'CustomerReponseCustomerPerson' => '\\StructType\\CustomerReponseCustomerPerson',
            'CustomerReponseCustomerRecurringDayProgrammeOperationHours' => '\\StructType\\CustomerReponseCustomerRecurringDayProgrammeOperationHours',
            'CustomerReponseCustomerRelationship' => '\\StructType\\CustomerReponseCustomerRelationship',
            'CustomerReponseCustomerSalesArrangement' => '\\StructType\\CustomerReponseCustomerSalesArrangement',
            'CustomerReponseCustomerTaxNumber' => '\\StructType\\CustomerReponseCustomerTaxNumber',
            'CustomerReponseCustomerText' => '\\StructType\\CustomerReponseCustomerText',
            'CustomerReponseCustomerWorkplaceTelephone' => '\\StructType\\CustomerReponseCustomerWorkplaceTelephone',
            'CustomerRequestedElements' => '\\StructType\\CustomerRequestedElements',
            'CustomerRequestedElementsCustomer' => '\\StructType\\CustomerRequestedElementsCustomer',
            'CustomerResponseCustomerTaxExemptionCertificate' => '\\StructType\\CustomerResponseCustomerTaxExemptionCertificate',
            'CustomerResponseCustomerTaxExemptionCertificateTaxExemptionReason' => '\\StructType\\CustomerResponseCustomerTaxExemptionCertificateTaxExemptionReason',
            'CustomerResponseMessage_sync' => '\\StructType\\CustomerResponseMessage_sync',
            'CustomerSelectionByBusinessCharacterCode' => '\\StructType\\CustomerSelectionByBusinessCharacterCode',
            'CustomerSelectionByBusinessPartnerAdditionalName' => '\\StructType\\CustomerSelectionByBusinessPartnerAdditionalName',
            'CustomerSelectionByBusinessPartnerID' => '\\StructType\\CustomerSelectionByBusinessPartnerID',
            'CustomerSelectionByBusinessPartnerName' => '\\StructType\\CustomerSelectionByBusinessPartnerName',
            'CustomerSelectionByCategoryCode' => '\\StructType\\CustomerSelectionByCategoryCode',
            'CustomerSelectionByChangeDateTime' => '\\StructType\\CustomerSelectionByChangeDateTime',
            'CustomerSelectionByCityName' => '\\StructType\\CustomerSelectionByCityName',
            'CustomerSelectionByCommunicationData' => '\\StructType\\CustomerSelectionByCommunicationData',
            'CustomerSelectionByCountryCode' => '\\StructType\\CustomerSelectionByCountryCode',
            'CustomerSelectionByCreationDateTime' => '\\StructType\\CustomerSelectionByCreationDateTime',
            'CustomerSelectionByCustomerABCClassificationCode' => '\\StructType\\CustomerSelectionByCustomerABCClassificationCode',
            'CustomerSelectionByElements' => '\\StructType\\CustomerSelectionByElements',
            'CustomerSelectionByEmailURI' => '\\StructType\\CustomerSelectionByEmailURI',
            'CustomerSelectionByIdentification' => '\\StructType\\CustomerSelectionByIdentification',
            'CustomerSelectionByIdentityID' => '\\StructType\\CustomerSelectionByIdentityID',
            'CustomerSelectionByIndustrialSectorCode' => '\\StructType\\CustomerSelectionByIndustrialSectorCode',
            'CustomerSelectionByInternalID' => '\\StructType\\CustomerSelectionByInternalID',
            'CustomerSelectionByLifeCycleStatusCode' => '\\StructType\\CustomerSelectionByLifeCycleStatusCode',
            'CustomerSelectionByNormalisedFacsimileNumber' => '\\StructType\\CustomerSelectionByNormalisedFacsimileNumber',
            'CustomerSelectionByNormalisedTelephoneNumber' => '\\StructType\\CustomerSelectionByNormalisedTelephoneNumber',
            'CustomerSelectionByPartyIdentifierTypeCode' => '\\StructType\\CustomerSelectionByPartyIdentifierTypeCode',
            'CustomerSelectionByRegionCode' => '\\StructType\\CustomerSelectionByRegionCode',
            'CustomerSelectionByRoleCode' => '\\StructType\\CustomerSelectionByRoleCode',
            'CustomerSelectionBySalesOrganisationID' => '\\StructType\\CustomerSelectionBySalesOrganisationID',
            'CustomerSelectionBySortingFormattedName' => '\\StructType\\CustomerSelectionBySortingFormattedName',
            'CustomerSelectionByStreetPostalCode' => '\\StructType\\CustomerSelectionByStreetPostalCode',
            'CustomerSelectionByUUID' => '\\StructType\\CustomerSelectionByUUID',
            'AcademicTitleCode' => '\\StructType\\AcademicTitleCode',
            'AddressUsageCode' => '\\StructType\\AddressUsageCode',
            'Amount' => '\\StructType\\Amount',
            'BUSINESSPARTNER_PartyBusinessCharacterCode' => '\\StructType\\BUSINESSPARTNER_PartyBusinessCharacterCode',
            'BankBranchID' => '\\StructType\\BankBranchID',
            'BankInternalID' => '\\StructType\\BankInternalID',
            'BusinessPartnerFunctionTypeCode' => '\\StructType\\BusinessPartnerFunctionTypeCode',
            'BusinessPartnerFunctionalAreaCode' => '\\StructType\\BusinessPartnerFunctionalAreaCode',
            'BusinessPartnerRelationshipRoleCode' => '\\StructType\\BusinessPartnerRelationshipRoleCode',
            'BusinessPartnerRoleCode' => '\\StructType\\BusinessPartnerRoleCode',
            'CLOSED_DatePeriod' => '\\StructType\\CLOSED_DatePeriod',
            'CashDiscountTermsCode' => '\\StructType\\CashDiscountTermsCode',
            'CommunicationMediumTypeCode' => '\\StructType\\CommunicationMediumTypeCode',
            'CompanyLegalFormCode' => '\\StructType\\CompanyLegalFormCode',
            'CompoundServiceInterfaceCode' => '\\StructType\\CompoundServiceInterfaceCode',
            'CustomerABCClassificationCode' => '\\StructType\\CustomerABCClassificationCode',
            'CustomerGroupCode' => '\\StructType\\CustomerGroupCode',
            'Description' => '\\StructType\\Description',
            'DistributionChannelCode' => '\\StructType\\DistributionChannelCode',
            'DocumentTypeCode' => '\\StructType\\DocumentTypeCode',
            'EmailURI' => '\\StructType\\EmailURI',
            'EmployeeID' => '\\StructType\\EmployeeID',
            'FormOfAddressCode' => '\\StructType\\FormOfAddressCode',
            'FormattedAddress' => '\\StructType\\FormattedAddress',
            'FormattedPostalAddress' => '\\StructType\\FormattedPostalAddress',
            'IdentityID' => '\\StructType\\IdentityID',
            'Incoterms' => '\\StructType\\Incoterms',
            'IndustrialSectorCode' => '\\StructType\\IndustrialSectorCode',
            'Log' => '\\StructType\\Log',
            'LogItem' => '\\StructType\\LogItem',
            'LogItemCategoryCode' => '\\StructType\\LogItemCategoryCode',
            'LogItemNotePlaceholderSubstitutionList' => '\\StructType\\LogItemNotePlaceholderSubstitutionList',
            'MaritalStatusCode' => '\\StructType\\MaritalStatusCode',
            'Measure' => '\\StructType\\Measure',
            'NamespaceURI' => '\\StructType\\NamespaceURI',
            'NielsenRegionCode' => '\\StructType\\NielsenRegionCode',
            'NumberID' => '\\StructType\\NumberID',
            'ObjectID' => '\\StructType\\ObjectID',
            'OccupationCode' => '\\StructType\\OccupationCode',
            'OutputRequestFormTemplateCode' => '\\StructType\\OutputRequestFormTemplateCode',
            'PartyIdentifierTypeCode' => '\\StructType\\PartyIdentifierTypeCode',
            'PartyTaxID' => '\\StructType\\PartyTaxID',
            'PaymentBlockingReasonCode' => '\\StructType\\PaymentBlockingReasonCode',
            'PaymentCardBlockingReasonCode' => '\\StructType\\PaymentCardBlockingReasonCode',
            'PaymentCardID' => '\\StructType\\PaymentCardID',
            'PaymentCardTypeCode' => '\\StructType\\PaymentCardTypeCode',
            'QueryProcessingConditions' => '\\StructType\\QueryProcessingConditions',
            'RegionCode' => '\\StructType\\RegionCode',
            'ResponseProcessingConditions' => '\\StructType\\ResponseProcessingConditions',
            'SystemAdministrativeData' => '\\StructType\\SystemAdministrativeData',
            'TaxExemptionCertificateID' => '\\StructType\\TaxExemptionCertificateID',
            'TaxExemptionCertificateTypeCode' => '\\StructType\\TaxExemptionCertificateTypeCode',
            'TaxExemptionReasonCode' => '\\StructType\\TaxExemptionReasonCode',
            'TaxIdentificationNumberTypeCode' => '\\StructType\\TaxIdentificationNumberTypeCode',
            'TaxJurisdictionCode' => '\\StructType\\TaxJurisdictionCode',
            'TaxPayerCategoryCode' => '\\StructType\\TaxPayerCategoryCode',
            'TaxTypeCode' => '\\StructType\\TaxTypeCode',
            'TextCollectionTextTypeCode' => '\\StructType\\TextCollectionTextTypeCode',
            'UPPEROPEN_TimePeriod' => '\\StructType\\UPPEROPEN_TimePeriod',
            'URI' => '\\StructType\\URI',
            'UUID' => '\\StructType\\UUID',
            'VIPReasonCode' => '\\StructType\\VIPReasonCode',
            'WeekdaySelection' => '\\StructType\\WeekdaySelection',
            'AccessAttachmentFolder' => '\\StructType\\AccessAttachmentFolder',
            'AccessAttachmentFolderDocument' => '\\StructType\\AccessAttachmentFolderDocument',
            'AccessAttachmentFolderDocumentProperty' => '\\StructType\\AccessAttachmentFolderDocumentProperty',
            'AccessAttachmentFolderDocumentPropertyPropertyValue' => '\\StructType\\AccessAttachmentFolderDocumentPropertyPropertyValue',
            'AccountDeterminationDebtorGroupCode' => '\\StructType\\AccountDeterminationDebtorGroupCode',
            'Code' => '\\StructType\\Code',
            'ExtSelectionByCode' => '\\StructType\\ExtSelectionByCode',
            'ExtSelectionByIdentifier' => '\\StructType\\ExtSelectionByIdentifier',
            'ExtSelectionByIndicator' => '\\StructType\\ExtSelectionByIndicator',
            'ExtSelectionByLongText' => '\\StructType\\ExtSelectionByLongText',
            'ExtSelectionByMediumText' => '\\StructType\\ExtSelectionByMediumText',
            'ExtSelectionByText' => '\\StructType\\ExtSelectionByText',
            'XSLTStorageXSLTID' => '\\StructType\\XSLTStorageXSLTID',
        );
    }
}
