<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CustomerReponseCustomerAddressUsage StructType
 * @subpackage Structs
 */
class CustomerReponseCustomerAddressUsage extends AbstractStructBase
{
    /**
     * The AddressUsageCode
     * @var \StructType\AddressUsageCode
     */
    public $AddressUsageCode;
    /**
     * The DefaultIndicator
     * Meta information extracted from the WSDL
     * - documentation: Indicator
     * - base: xsd:boolean
     * - minOccurs: 0
     * @var bool
     */
    public $DefaultIndicator;
    /**
     * The AddressUsageValidityPeriod
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\CLOSED_DatePeriod
     */
    public $AddressUsageValidityPeriod;
    /**
     * Constructor method for CustomerReponseCustomerAddressUsage
     * @uses CustomerReponseCustomerAddressUsage::setAddressUsageCode()
     * @uses CustomerReponseCustomerAddressUsage::setDefaultIndicator()
     * @uses CustomerReponseCustomerAddressUsage::setAddressUsageValidityPeriod()
     * @param \StructType\AddressUsageCode $addressUsageCode
     * @param bool $defaultIndicator
     * @param \StructType\CLOSED_DatePeriod $addressUsageValidityPeriod
     */
    public function __construct(\StructType\AddressUsageCode $addressUsageCode = null, $defaultIndicator = null, \StructType\CLOSED_DatePeriod $addressUsageValidityPeriod = null)
    {
        $this
            ->setAddressUsageCode($addressUsageCode)
            ->setDefaultIndicator($defaultIndicator)
            ->setAddressUsageValidityPeriod($addressUsageValidityPeriod);
    }
    /**
     * Get AddressUsageCode value
     * @return \StructType\AddressUsageCode|null
     */
    public function getAddressUsageCode()
    {
        return $this->AddressUsageCode;
    }
    /**
     * Set AddressUsageCode value
     * @param \StructType\AddressUsageCode $addressUsageCode
     * @return \StructType\CustomerReponseCustomerAddressUsage
     */
    public function setAddressUsageCode(\StructType\AddressUsageCode $addressUsageCode = null)
    {
        $this->AddressUsageCode = $addressUsageCode;
        return $this;
    }
    /**
     * Get DefaultIndicator value
     * @return bool|null
     */
    public function getDefaultIndicator()
    {
        return $this->DefaultIndicator;
    }
    /**
     * Set DefaultIndicator value
     * @param bool $defaultIndicator
     * @return \StructType\CustomerReponseCustomerAddressUsage
     */
    public function setDefaultIndicator($defaultIndicator = null)
    {
        // validation for constraint: boolean
        if (!is_null($defaultIndicator) && !is_bool($defaultIndicator)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($defaultIndicator, true), gettype($defaultIndicator)), __LINE__);
        }
        $this->DefaultIndicator = $defaultIndicator;
        return $this;
    }
    /**
     * Get AddressUsageValidityPeriod value
     * @return \StructType\CLOSED_DatePeriod|null
     */
    public function getAddressUsageValidityPeriod()
    {
        return $this->AddressUsageValidityPeriod;
    }
    /**
     * Set AddressUsageValidityPeriod value
     * @param \StructType\CLOSED_DatePeriod $addressUsageValidityPeriod
     * @return \StructType\CustomerReponseCustomerAddressUsage
     */
    public function setAddressUsageValidityPeriod(\StructType\CLOSED_DatePeriod $addressUsageValidityPeriod = null)
    {
        $this->AddressUsageValidityPeriod = $addressUsageValidityPeriod;
        return $this;
    }
}
