<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for
 * CustomerReponseCustomerCommunicationArrangementMultiChannel StructType
 * @subpackage Structs
 */
class CustomerReponseCustomerCommunicationArrangementMultiChannel extends AbstractStructBase
{
    /**
     * The CompoundServiceInterfaceCode
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\CompoundServiceInterfaceCode
     */
    public $CompoundServiceInterfaceCode;
    /**
     * The EnabledIndicator
     * Meta information extracted from the WSDL
     * - documentation: Indicator
     * - base: xsd:boolean
     * - minOccurs: 0
     * @var bool
     */
    public $EnabledIndicator;
    /**
     * The CommunicationChannel
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\CustomerReponseCustomerCommunicationChannel[]
     */
    public $CommunicationChannel;
    /**
     * Constructor method for
     * CustomerReponseCustomerCommunicationArrangementMultiChannel
     * @uses CustomerReponseCustomerCommunicationArrangementMultiChannel::setCompoundServiceInterfaceCode()
     * @uses CustomerReponseCustomerCommunicationArrangementMultiChannel::setEnabledIndicator()
     * @uses CustomerReponseCustomerCommunicationArrangementMultiChannel::setCommunicationChannel()
     * @param \StructType\CompoundServiceInterfaceCode $compoundServiceInterfaceCode
     * @param bool $enabledIndicator
     * @param \StructType\CustomerReponseCustomerCommunicationChannel[] $communicationChannel
     */
    public function __construct(\StructType\CompoundServiceInterfaceCode $compoundServiceInterfaceCode = null, $enabledIndicator = null, array $communicationChannel = array())
    {
        $this
            ->setCompoundServiceInterfaceCode($compoundServiceInterfaceCode)
            ->setEnabledIndicator($enabledIndicator)
            ->setCommunicationChannel($communicationChannel);
    }
    /**
     * Get CompoundServiceInterfaceCode value
     * @return \StructType\CompoundServiceInterfaceCode|null
     */
    public function getCompoundServiceInterfaceCode()
    {
        return $this->CompoundServiceInterfaceCode;
    }
    /**
     * Set CompoundServiceInterfaceCode value
     * @param \StructType\CompoundServiceInterfaceCode $compoundServiceInterfaceCode
     * @return \StructType\CustomerReponseCustomerCommunicationArrangementMultiChannel
     */
    public function setCompoundServiceInterfaceCode(\StructType\CompoundServiceInterfaceCode $compoundServiceInterfaceCode = null)
    {
        $this->CompoundServiceInterfaceCode = $compoundServiceInterfaceCode;
        return $this;
    }
    /**
     * Get EnabledIndicator value
     * @return bool|null
     */
    public function getEnabledIndicator()
    {
        return $this->EnabledIndicator;
    }
    /**
     * Set EnabledIndicator value
     * @param bool $enabledIndicator
     * @return \StructType\CustomerReponseCustomerCommunicationArrangementMultiChannel
     */
    public function setEnabledIndicator($enabledIndicator = null)
    {
        // validation for constraint: boolean
        if (!is_null($enabledIndicator) && !is_bool($enabledIndicator)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($enabledIndicator, true), gettype($enabledIndicator)), __LINE__);
        }
        $this->EnabledIndicator = $enabledIndicator;
        return $this;
    }
    /**
     * Get CommunicationChannel value
     * @return \StructType\CustomerReponseCustomerCommunicationChannel[]|null
     */
    public function getCommunicationChannel()
    {
        return $this->CommunicationChannel;
    }
    /**
     * This method is responsible for validating the values passed to the setCommunicationChannel method
     * This method is willingly generated in order to preserve the one-line inline validation within the setCommunicationChannel method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateCommunicationChannelForArrayConstraintsFromSetCommunicationChannel(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $customerReponseCustomerCommunicationArrangementMultiChannelCommunicationChannelItem) {
            // validation for constraint: itemType
            if (!$customerReponseCustomerCommunicationArrangementMultiChannelCommunicationChannelItem instanceof \StructType\CustomerReponseCustomerCommunicationChannel) {
                $invalidValues[] = is_object($customerReponseCustomerCommunicationArrangementMultiChannelCommunicationChannelItem) ? get_class($customerReponseCustomerCommunicationArrangementMultiChannelCommunicationChannelItem) : sprintf('%s(%s)', gettype($customerReponseCustomerCommunicationArrangementMultiChannelCommunicationChannelItem), var_export($customerReponseCustomerCommunicationArrangementMultiChannelCommunicationChannelItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The CommunicationChannel property can only contain items of type \StructType\CustomerReponseCustomerCommunicationChannel, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set CommunicationChannel value
     * @throws \InvalidArgumentException
     * @param \StructType\CustomerReponseCustomerCommunicationChannel[] $communicationChannel
     * @return \StructType\CustomerReponseCustomerCommunicationArrangementMultiChannel
     */
    public function setCommunicationChannel(array $communicationChannel = array())
    {
        // validation for constraint: array
        if ('' !== ($communicationChannelArrayErrorMessage = self::validateCommunicationChannelForArrayConstraintsFromSetCommunicationChannel($communicationChannel))) {
            throw new \InvalidArgumentException($communicationChannelArrayErrorMessage, __LINE__);
        }
        $this->CommunicationChannel = $communicationChannel;
        return $this;
    }
    /**
     * Add item to CommunicationChannel value
     * @throws \InvalidArgumentException
     * @param \StructType\CustomerReponseCustomerCommunicationChannel $item
     * @return \StructType\CustomerReponseCustomerCommunicationArrangementMultiChannel
     */
    public function addToCommunicationChannel(\StructType\CustomerReponseCustomerCommunicationChannel $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\CustomerReponseCustomerCommunicationChannel) {
            throw new \InvalidArgumentException(sprintf('The CommunicationChannel property can only contain items of type \StructType\CustomerReponseCustomerCommunicationChannel, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->CommunicationChannel[] = $item;
        return $this;
    }
}
