<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for
 * CustomerReponseCustomerOperatingHoursInformationRecurringDayProgramme StructType
 * @subpackage Structs
 */
class CustomerReponseCustomerOperatingHoursInformationRecurringDayProgramme extends AbstractStructBase
{
    /**
     * The WeekdaySelection
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\WeekdaySelection
     */
    public $WeekdaySelection;
    /**
     * The OperatingHours
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\CustomerReponseCustomerRecurringDayProgrammeOperationHours[]
     */
    public $OperatingHours;
    /**
     * Constructor method for
     * CustomerReponseCustomerOperatingHoursInformationRecurringDayProgramme
     * @uses CustomerReponseCustomerOperatingHoursInformationRecurringDayProgramme::setWeekdaySelection()
     * @uses CustomerReponseCustomerOperatingHoursInformationRecurringDayProgramme::setOperatingHours()
     * @param \StructType\WeekdaySelection $weekdaySelection
     * @param \StructType\CustomerReponseCustomerRecurringDayProgrammeOperationHours[] $operatingHours
     */
    public function __construct(\StructType\WeekdaySelection $weekdaySelection = null, array $operatingHours = array())
    {
        $this
            ->setWeekdaySelection($weekdaySelection)
            ->setOperatingHours($operatingHours);
    }
    /**
     * Get WeekdaySelection value
     * @return \StructType\WeekdaySelection|null
     */
    public function getWeekdaySelection()
    {
        return $this->WeekdaySelection;
    }
    /**
     * Set WeekdaySelection value
     * @param \StructType\WeekdaySelection $weekdaySelection
     * @return \StructType\CustomerReponseCustomerOperatingHoursInformationRecurringDayProgramme
     */
    public function setWeekdaySelection(\StructType\WeekdaySelection $weekdaySelection = null)
    {
        $this->WeekdaySelection = $weekdaySelection;
        return $this;
    }
    /**
     * Get OperatingHours value
     * @return \StructType\CustomerReponseCustomerRecurringDayProgrammeOperationHours[]|null
     */
    public function getOperatingHours()
    {
        return $this->OperatingHours;
    }
    /**
     * This method is responsible for validating the values passed to the setOperatingHours method
     * This method is willingly generated in order to preserve the one-line inline validation within the setOperatingHours method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateOperatingHoursForArrayConstraintsFromSetOperatingHours(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $customerReponseCustomerOperatingHoursInformationRecurringDayProgrammeOperatingHoursItem) {
            // validation for constraint: itemType
            if (!$customerReponseCustomerOperatingHoursInformationRecurringDayProgrammeOperatingHoursItem instanceof \StructType\CustomerReponseCustomerRecurringDayProgrammeOperationHours) {
                $invalidValues[] = is_object($customerReponseCustomerOperatingHoursInformationRecurringDayProgrammeOperatingHoursItem) ? get_class($customerReponseCustomerOperatingHoursInformationRecurringDayProgrammeOperatingHoursItem) : sprintf('%s(%s)', gettype($customerReponseCustomerOperatingHoursInformationRecurringDayProgrammeOperatingHoursItem), var_export($customerReponseCustomerOperatingHoursInformationRecurringDayProgrammeOperatingHoursItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The OperatingHours property can only contain items of type \StructType\CustomerReponseCustomerRecurringDayProgrammeOperationHours, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set OperatingHours value
     * @throws \InvalidArgumentException
     * @param \StructType\CustomerReponseCustomerRecurringDayProgrammeOperationHours[] $operatingHours
     * @return \StructType\CustomerReponseCustomerOperatingHoursInformationRecurringDayProgramme
     */
    public function setOperatingHours(array $operatingHours = array())
    {
        // validation for constraint: array
        if ('' !== ($operatingHoursArrayErrorMessage = self::validateOperatingHoursForArrayConstraintsFromSetOperatingHours($operatingHours))) {
            throw new \InvalidArgumentException($operatingHoursArrayErrorMessage, __LINE__);
        }
        $this->OperatingHours = $operatingHours;
        return $this;
    }
    /**
     * Add item to OperatingHours value
     * @throws \InvalidArgumentException
     * @param \StructType\CustomerReponseCustomerRecurringDayProgrammeOperationHours $item
     * @return \StructType\CustomerReponseCustomerOperatingHoursInformationRecurringDayProgramme
     */
    public function addToOperatingHours(\StructType\CustomerReponseCustomerRecurringDayProgrammeOperationHours $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\CustomerReponseCustomerRecurringDayProgrammeOperationHours) {
            throw new \InvalidArgumentException(sprintf('The OperatingHours property can only contain items of type \StructType\CustomerReponseCustomerRecurringDayProgrammeOperationHours, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->OperatingHours[] = $item;
        return $this;
    }
}
