<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CustomerSelectionByCommunicationData StructType
 * @subpackage Structs
 */
class CustomerSelectionByCommunicationData extends AbstractStructBase
{
    /**
     * The SelectionByNormalisedTelephoneNumber
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\CustomerSelectionByNormalisedTelephoneNumber[]
     */
    public $SelectionByNormalisedTelephoneNumber;
    /**
     * The SelectionByNormalisedFacsimileNumber
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\CustomerSelectionByNormalisedFacsimileNumber[]
     */
    public $SelectionByNormalisedFacsimileNumber;
    /**
     * The SelectionByEmailURI
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\CustomerSelectionByEmailURI[]
     */
    public $SelectionByEmailURI;
    /**
     * The SelectionByInternalID
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\CustomerSelectionByInternalID[]
     */
    public $SelectionByInternalID;
    /**
     * The SelectionByUUID
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\CustomerSelectionByUUID[]
     */
    public $SelectionByUUID;
    /**
     * The SelectionByCategoryCode
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\CustomerSelectionByCategoryCode[]
     */
    public $SelectionByCategoryCode;
    /**
     * The SelectionByBusinessCharacterCode
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\CustomerSelectionByBusinessCharacterCode[]
     */
    public $SelectionByBusinessCharacterCode;
    /**
     * The SelectionByBusinessPartnerName
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\CustomerSelectionByBusinessPartnerName[]
     */
    public $SelectionByBusinessPartnerName;
    /**
     * The SelectionByBusinessPartnerAdditionalName
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\CustomerSelectionByBusinessPartnerAdditionalName[]
     */
    public $SelectionByBusinessPartnerAdditionalName;
    /**
     * The SelectionBySortingFormattedName
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\CustomerSelectionBySortingFormattedName[]
     */
    public $SelectionBySortingFormattedName;
    /**
     * The SelectionByLifeCycleStatusCode
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\CustomerSelectionByLifeCycleStatusCode[]
     */
    public $SelectionByLifeCycleStatusCode;
    /**
     * The SelectionBySearchText
     * Meta information extracted from the WSDL
     * - documentation: Text
     * - base: xsd:string
     * - minOccurs: 0
     * @var string
     */
    public $SelectionBySearchText;
    /**
     * Constructor method for CustomerSelectionByCommunicationData
     * @uses CustomerSelectionByCommunicationData::setSelectionByNormalisedTelephoneNumber()
     * @uses CustomerSelectionByCommunicationData::setSelectionByNormalisedFacsimileNumber()
     * @uses CustomerSelectionByCommunicationData::setSelectionByEmailURI()
     * @uses CustomerSelectionByCommunicationData::setSelectionByInternalID()
     * @uses CustomerSelectionByCommunicationData::setSelectionByUUID()
     * @uses CustomerSelectionByCommunicationData::setSelectionByCategoryCode()
     * @uses CustomerSelectionByCommunicationData::setSelectionByBusinessCharacterCode()
     * @uses CustomerSelectionByCommunicationData::setSelectionByBusinessPartnerName()
     * @uses CustomerSelectionByCommunicationData::setSelectionByBusinessPartnerAdditionalName()
     * @uses CustomerSelectionByCommunicationData::setSelectionBySortingFormattedName()
     * @uses CustomerSelectionByCommunicationData::setSelectionByLifeCycleStatusCode()
     * @uses CustomerSelectionByCommunicationData::setSelectionBySearchText()
     * @param \StructType\CustomerSelectionByNormalisedTelephoneNumber[] $selectionByNormalisedTelephoneNumber
     * @param \StructType\CustomerSelectionByNormalisedFacsimileNumber[] $selectionByNormalisedFacsimileNumber
     * @param \StructType\CustomerSelectionByEmailURI[] $selectionByEmailURI
     * @param \StructType\CustomerSelectionByInternalID[] $selectionByInternalID
     * @param \StructType\CustomerSelectionByUUID[] $selectionByUUID
     * @param \StructType\CustomerSelectionByCategoryCode[] $selectionByCategoryCode
     * @param \StructType\CustomerSelectionByBusinessCharacterCode[] $selectionByBusinessCharacterCode
     * @param \StructType\CustomerSelectionByBusinessPartnerName[] $selectionByBusinessPartnerName
     * @param \StructType\CustomerSelectionByBusinessPartnerAdditionalName[] $selectionByBusinessPartnerAdditionalName
     * @param \StructType\CustomerSelectionBySortingFormattedName[] $selectionBySortingFormattedName
     * @param \StructType\CustomerSelectionByLifeCycleStatusCode[] $selectionByLifeCycleStatusCode
     * @param string $selectionBySearchText
     */
    public function __construct(array $selectionByNormalisedTelephoneNumber = array(), array $selectionByNormalisedFacsimileNumber = array(), array $selectionByEmailURI = array(), array $selectionByInternalID = array(), array $selectionByUUID = array(), array $selectionByCategoryCode = array(), array $selectionByBusinessCharacterCode = array(), array $selectionByBusinessPartnerName = array(), array $selectionByBusinessPartnerAdditionalName = array(), array $selectionBySortingFormattedName = array(), array $selectionByLifeCycleStatusCode = array(), $selectionBySearchText = null)
    {
        $this
            ->setSelectionByNormalisedTelephoneNumber($selectionByNormalisedTelephoneNumber)
            ->setSelectionByNormalisedFacsimileNumber($selectionByNormalisedFacsimileNumber)
            ->setSelectionByEmailURI($selectionByEmailURI)
            ->setSelectionByInternalID($selectionByInternalID)
            ->setSelectionByUUID($selectionByUUID)
            ->setSelectionByCategoryCode($selectionByCategoryCode)
            ->setSelectionByBusinessCharacterCode($selectionByBusinessCharacterCode)
            ->setSelectionByBusinessPartnerName($selectionByBusinessPartnerName)
            ->setSelectionByBusinessPartnerAdditionalName($selectionByBusinessPartnerAdditionalName)
            ->setSelectionBySortingFormattedName($selectionBySortingFormattedName)
            ->setSelectionByLifeCycleStatusCode($selectionByLifeCycleStatusCode)
            ->setSelectionBySearchText($selectionBySearchText);
    }
    /**
     * Get SelectionByNormalisedTelephoneNumber value
     * @return \StructType\CustomerSelectionByNormalisedTelephoneNumber[]|null
     */
    public function getSelectionByNormalisedTelephoneNumber()
    {
        return $this->SelectionByNormalisedTelephoneNumber;
    }
    /**
     * This method is responsible for validating the values passed to the setSelectionByNormalisedTelephoneNumber method
     * This method is willingly generated in order to preserve the one-line inline validation within the setSelectionByNormalisedTelephoneNumber method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateSelectionByNormalisedTelephoneNumberForArrayConstraintsFromSetSelectionByNormalisedTelephoneNumber(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $customerSelectionByCommunicationDataSelectionByNormalisedTelephoneNumberItem) {
            // validation for constraint: itemType
            if (!$customerSelectionByCommunicationDataSelectionByNormalisedTelephoneNumberItem instanceof \StructType\CustomerSelectionByNormalisedTelephoneNumber) {
                $invalidValues[] = is_object($customerSelectionByCommunicationDataSelectionByNormalisedTelephoneNumberItem) ? get_class($customerSelectionByCommunicationDataSelectionByNormalisedTelephoneNumberItem) : sprintf('%s(%s)', gettype($customerSelectionByCommunicationDataSelectionByNormalisedTelephoneNumberItem), var_export($customerSelectionByCommunicationDataSelectionByNormalisedTelephoneNumberItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The SelectionByNormalisedTelephoneNumber property can only contain items of type \StructType\CustomerSelectionByNormalisedTelephoneNumber, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set SelectionByNormalisedTelephoneNumber value
     * @throws \InvalidArgumentException
     * @param \StructType\CustomerSelectionByNormalisedTelephoneNumber[] $selectionByNormalisedTelephoneNumber
     * @return \StructType\CustomerSelectionByCommunicationData
     */
    public function setSelectionByNormalisedTelephoneNumber(array $selectionByNormalisedTelephoneNumber = array())
    {
        // validation for constraint: array
        if ('' !== ($selectionByNormalisedTelephoneNumberArrayErrorMessage = self::validateSelectionByNormalisedTelephoneNumberForArrayConstraintsFromSetSelectionByNormalisedTelephoneNumber($selectionByNormalisedTelephoneNumber))) {
            throw new \InvalidArgumentException($selectionByNormalisedTelephoneNumberArrayErrorMessage, __LINE__);
        }
        $this->SelectionByNormalisedTelephoneNumber = $selectionByNormalisedTelephoneNumber;
        return $this;
    }
    /**
     * Add item to SelectionByNormalisedTelephoneNumber value
     * @throws \InvalidArgumentException
     * @param \StructType\CustomerSelectionByNormalisedTelephoneNumber $item
     * @return \StructType\CustomerSelectionByCommunicationData
     */
    public function addToSelectionByNormalisedTelephoneNumber(\StructType\CustomerSelectionByNormalisedTelephoneNumber $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\CustomerSelectionByNormalisedTelephoneNumber) {
            throw new \InvalidArgumentException(sprintf('The SelectionByNormalisedTelephoneNumber property can only contain items of type \StructType\CustomerSelectionByNormalisedTelephoneNumber, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->SelectionByNormalisedTelephoneNumber[] = $item;
        return $this;
    }
    /**
     * Get SelectionByNormalisedFacsimileNumber value
     * @return \StructType\CustomerSelectionByNormalisedFacsimileNumber[]|null
     */
    public function getSelectionByNormalisedFacsimileNumber()
    {
        return $this->SelectionByNormalisedFacsimileNumber;
    }
    /**
     * This method is responsible for validating the values passed to the setSelectionByNormalisedFacsimileNumber method
     * This method is willingly generated in order to preserve the one-line inline validation within the setSelectionByNormalisedFacsimileNumber method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateSelectionByNormalisedFacsimileNumberForArrayConstraintsFromSetSelectionByNormalisedFacsimileNumber(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $customerSelectionByCommunicationDataSelectionByNormalisedFacsimileNumberItem) {
            // validation for constraint: itemType
            if (!$customerSelectionByCommunicationDataSelectionByNormalisedFacsimileNumberItem instanceof \StructType\CustomerSelectionByNormalisedFacsimileNumber) {
                $invalidValues[] = is_object($customerSelectionByCommunicationDataSelectionByNormalisedFacsimileNumberItem) ? get_class($customerSelectionByCommunicationDataSelectionByNormalisedFacsimileNumberItem) : sprintf('%s(%s)', gettype($customerSelectionByCommunicationDataSelectionByNormalisedFacsimileNumberItem), var_export($customerSelectionByCommunicationDataSelectionByNormalisedFacsimileNumberItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The SelectionByNormalisedFacsimileNumber property can only contain items of type \StructType\CustomerSelectionByNormalisedFacsimileNumber, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set SelectionByNormalisedFacsimileNumber value
     * @throws \InvalidArgumentException
     * @param \StructType\CustomerSelectionByNormalisedFacsimileNumber[] $selectionByNormalisedFacsimileNumber
     * @return \StructType\CustomerSelectionByCommunicationData
     */
    public function setSelectionByNormalisedFacsimileNumber(array $selectionByNormalisedFacsimileNumber = array())
    {
        // validation for constraint: array
        if ('' !== ($selectionByNormalisedFacsimileNumberArrayErrorMessage = self::validateSelectionByNormalisedFacsimileNumberForArrayConstraintsFromSetSelectionByNormalisedFacsimileNumber($selectionByNormalisedFacsimileNumber))) {
            throw new \InvalidArgumentException($selectionByNormalisedFacsimileNumberArrayErrorMessage, __LINE__);
        }
        $this->SelectionByNormalisedFacsimileNumber = $selectionByNormalisedFacsimileNumber;
        return $this;
    }
    /**
     * Add item to SelectionByNormalisedFacsimileNumber value
     * @throws \InvalidArgumentException
     * @param \StructType\CustomerSelectionByNormalisedFacsimileNumber $item
     * @return \StructType\CustomerSelectionByCommunicationData
     */
    public function addToSelectionByNormalisedFacsimileNumber(\StructType\CustomerSelectionByNormalisedFacsimileNumber $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\CustomerSelectionByNormalisedFacsimileNumber) {
            throw new \InvalidArgumentException(sprintf('The SelectionByNormalisedFacsimileNumber property can only contain items of type \StructType\CustomerSelectionByNormalisedFacsimileNumber, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->SelectionByNormalisedFacsimileNumber[] = $item;
        return $this;
    }
    /**
     * Get SelectionByEmailURI value
     * @return \StructType\CustomerSelectionByEmailURI[]|null
     */
    public function getSelectionByEmailURI()
    {
        return $this->SelectionByEmailURI;
    }
    /**
     * This method is responsible for validating the values passed to the setSelectionByEmailURI method
     * This method is willingly generated in order to preserve the one-line inline validation within the setSelectionByEmailURI method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateSelectionByEmailURIForArrayConstraintsFromSetSelectionByEmailURI(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $customerSelectionByCommunicationDataSelectionByEmailURIItem) {
            // validation for constraint: itemType
            if (!$customerSelectionByCommunicationDataSelectionByEmailURIItem instanceof \StructType\CustomerSelectionByEmailURI) {
                $invalidValues[] = is_object($customerSelectionByCommunicationDataSelectionByEmailURIItem) ? get_class($customerSelectionByCommunicationDataSelectionByEmailURIItem) : sprintf('%s(%s)', gettype($customerSelectionByCommunicationDataSelectionByEmailURIItem), var_export($customerSelectionByCommunicationDataSelectionByEmailURIItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The SelectionByEmailURI property can only contain items of type \StructType\CustomerSelectionByEmailURI, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set SelectionByEmailURI value
     * @throws \InvalidArgumentException
     * @param \StructType\CustomerSelectionByEmailURI[] $selectionByEmailURI
     * @return \StructType\CustomerSelectionByCommunicationData
     */
    public function setSelectionByEmailURI(array $selectionByEmailURI = array())
    {
        // validation for constraint: array
        if ('' !== ($selectionByEmailURIArrayErrorMessage = self::validateSelectionByEmailURIForArrayConstraintsFromSetSelectionByEmailURI($selectionByEmailURI))) {
            throw new \InvalidArgumentException($selectionByEmailURIArrayErrorMessage, __LINE__);
        }
        $this->SelectionByEmailURI = $selectionByEmailURI;
        return $this;
    }
    /**
     * Add item to SelectionByEmailURI value
     * @throws \InvalidArgumentException
     * @param \StructType\CustomerSelectionByEmailURI $item
     * @return \StructType\CustomerSelectionByCommunicationData
     */
    public function addToSelectionByEmailURI(\StructType\CustomerSelectionByEmailURI $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\CustomerSelectionByEmailURI) {
            throw new \InvalidArgumentException(sprintf('The SelectionByEmailURI property can only contain items of type \StructType\CustomerSelectionByEmailURI, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->SelectionByEmailURI[] = $item;
        return $this;
    }
    /**
     * Get SelectionByInternalID value
     * @return \StructType\CustomerSelectionByInternalID[]|null
     */
    public function getSelectionByInternalID()
    {
        return $this->SelectionByInternalID;
    }
    /**
     * This method is responsible for validating the values passed to the setSelectionByInternalID method
     * This method is willingly generated in order to preserve the one-line inline validation within the setSelectionByInternalID method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateSelectionByInternalIDForArrayConstraintsFromSetSelectionByInternalID(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $customerSelectionByCommunicationDataSelectionByInternalIDItem) {
            // validation for constraint: itemType
            if (!$customerSelectionByCommunicationDataSelectionByInternalIDItem instanceof \StructType\CustomerSelectionByInternalID) {
                $invalidValues[] = is_object($customerSelectionByCommunicationDataSelectionByInternalIDItem) ? get_class($customerSelectionByCommunicationDataSelectionByInternalIDItem) : sprintf('%s(%s)', gettype($customerSelectionByCommunicationDataSelectionByInternalIDItem), var_export($customerSelectionByCommunicationDataSelectionByInternalIDItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The SelectionByInternalID property can only contain items of type \StructType\CustomerSelectionByInternalID, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set SelectionByInternalID value
     * @throws \InvalidArgumentException
     * @param \StructType\CustomerSelectionByInternalID[] $selectionByInternalID
     * @return \StructType\CustomerSelectionByCommunicationData
     */
    public function setSelectionByInternalID(array $selectionByInternalID = array())
    {
        // validation for constraint: array
        if ('' !== ($selectionByInternalIDArrayErrorMessage = self::validateSelectionByInternalIDForArrayConstraintsFromSetSelectionByInternalID($selectionByInternalID))) {
            throw new \InvalidArgumentException($selectionByInternalIDArrayErrorMessage, __LINE__);
        }
        $this->SelectionByInternalID = $selectionByInternalID;
        return $this;
    }
    /**
     * Add item to SelectionByInternalID value
     * @throws \InvalidArgumentException
     * @param \StructType\CustomerSelectionByInternalID $item
     * @return \StructType\CustomerSelectionByCommunicationData
     */
    public function addToSelectionByInternalID(\StructType\CustomerSelectionByInternalID $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\CustomerSelectionByInternalID) {
            throw new \InvalidArgumentException(sprintf('The SelectionByInternalID property can only contain items of type \StructType\CustomerSelectionByInternalID, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->SelectionByInternalID[] = $item;
        return $this;
    }
    /**
     * Get SelectionByUUID value
     * @return \StructType\CustomerSelectionByUUID[]|null
     */
    public function getSelectionByUUID()
    {
        return $this->SelectionByUUID;
    }
    /**
     * This method is responsible for validating the values passed to the setSelectionByUUID method
     * This method is willingly generated in order to preserve the one-line inline validation within the setSelectionByUUID method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateSelectionByUUIDForArrayConstraintsFromSetSelectionByUUID(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $customerSelectionByCommunicationDataSelectionByUUIDItem) {
            // validation for constraint: itemType
            if (!$customerSelectionByCommunicationDataSelectionByUUIDItem instanceof \StructType\CustomerSelectionByUUID) {
                $invalidValues[] = is_object($customerSelectionByCommunicationDataSelectionByUUIDItem) ? get_class($customerSelectionByCommunicationDataSelectionByUUIDItem) : sprintf('%s(%s)', gettype($customerSelectionByCommunicationDataSelectionByUUIDItem), var_export($customerSelectionByCommunicationDataSelectionByUUIDItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The SelectionByUUID property can only contain items of type \StructType\CustomerSelectionByUUID, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set SelectionByUUID value
     * @throws \InvalidArgumentException
     * @param \StructType\CustomerSelectionByUUID[] $selectionByUUID
     * @return \StructType\CustomerSelectionByCommunicationData
     */
    public function setSelectionByUUID(array $selectionByUUID = array())
    {
        // validation for constraint: array
        if ('' !== ($selectionByUUIDArrayErrorMessage = self::validateSelectionByUUIDForArrayConstraintsFromSetSelectionByUUID($selectionByUUID))) {
            throw new \InvalidArgumentException($selectionByUUIDArrayErrorMessage, __LINE__);
        }
        $this->SelectionByUUID = $selectionByUUID;
        return $this;
    }
    /**
     * Add item to SelectionByUUID value
     * @throws \InvalidArgumentException
     * @param \StructType\CustomerSelectionByUUID $item
     * @return \StructType\CustomerSelectionByCommunicationData
     */
    public function addToSelectionByUUID(\StructType\CustomerSelectionByUUID $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\CustomerSelectionByUUID) {
            throw new \InvalidArgumentException(sprintf('The SelectionByUUID property can only contain items of type \StructType\CustomerSelectionByUUID, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->SelectionByUUID[] = $item;
        return $this;
    }
    /**
     * Get SelectionByCategoryCode value
     * @return \StructType\CustomerSelectionByCategoryCode[]|null
     */
    public function getSelectionByCategoryCode()
    {
        return $this->SelectionByCategoryCode;
    }
    /**
     * This method is responsible for validating the values passed to the setSelectionByCategoryCode method
     * This method is willingly generated in order to preserve the one-line inline validation within the setSelectionByCategoryCode method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateSelectionByCategoryCodeForArrayConstraintsFromSetSelectionByCategoryCode(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $customerSelectionByCommunicationDataSelectionByCategoryCodeItem) {
            // validation for constraint: itemType
            if (!$customerSelectionByCommunicationDataSelectionByCategoryCodeItem instanceof \StructType\CustomerSelectionByCategoryCode) {
                $invalidValues[] = is_object($customerSelectionByCommunicationDataSelectionByCategoryCodeItem) ? get_class($customerSelectionByCommunicationDataSelectionByCategoryCodeItem) : sprintf('%s(%s)', gettype($customerSelectionByCommunicationDataSelectionByCategoryCodeItem), var_export($customerSelectionByCommunicationDataSelectionByCategoryCodeItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The SelectionByCategoryCode property can only contain items of type \StructType\CustomerSelectionByCategoryCode, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set SelectionByCategoryCode value
     * @throws \InvalidArgumentException
     * @param \StructType\CustomerSelectionByCategoryCode[] $selectionByCategoryCode
     * @return \StructType\CustomerSelectionByCommunicationData
     */
    public function setSelectionByCategoryCode(array $selectionByCategoryCode = array())
    {
        // validation for constraint: array
        if ('' !== ($selectionByCategoryCodeArrayErrorMessage = self::validateSelectionByCategoryCodeForArrayConstraintsFromSetSelectionByCategoryCode($selectionByCategoryCode))) {
            throw new \InvalidArgumentException($selectionByCategoryCodeArrayErrorMessage, __LINE__);
        }
        $this->SelectionByCategoryCode = $selectionByCategoryCode;
        return $this;
    }
    /**
     * Add item to SelectionByCategoryCode value
     * @throws \InvalidArgumentException
     * @param \StructType\CustomerSelectionByCategoryCode $item
     * @return \StructType\CustomerSelectionByCommunicationData
     */
    public function addToSelectionByCategoryCode(\StructType\CustomerSelectionByCategoryCode $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\CustomerSelectionByCategoryCode) {
            throw new \InvalidArgumentException(sprintf('The SelectionByCategoryCode property can only contain items of type \StructType\CustomerSelectionByCategoryCode, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->SelectionByCategoryCode[] = $item;
        return $this;
    }
    /**
     * Get SelectionByBusinessCharacterCode value
     * @return \StructType\CustomerSelectionByBusinessCharacterCode[]|null
     */
    public function getSelectionByBusinessCharacterCode()
    {
        return $this->SelectionByBusinessCharacterCode;
    }
    /**
     * This method is responsible for validating the values passed to the setSelectionByBusinessCharacterCode method
     * This method is willingly generated in order to preserve the one-line inline validation within the setSelectionByBusinessCharacterCode method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateSelectionByBusinessCharacterCodeForArrayConstraintsFromSetSelectionByBusinessCharacterCode(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $customerSelectionByCommunicationDataSelectionByBusinessCharacterCodeItem) {
            // validation for constraint: itemType
            if (!$customerSelectionByCommunicationDataSelectionByBusinessCharacterCodeItem instanceof \StructType\CustomerSelectionByBusinessCharacterCode) {
                $invalidValues[] = is_object($customerSelectionByCommunicationDataSelectionByBusinessCharacterCodeItem) ? get_class($customerSelectionByCommunicationDataSelectionByBusinessCharacterCodeItem) : sprintf('%s(%s)', gettype($customerSelectionByCommunicationDataSelectionByBusinessCharacterCodeItem), var_export($customerSelectionByCommunicationDataSelectionByBusinessCharacterCodeItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The SelectionByBusinessCharacterCode property can only contain items of type \StructType\CustomerSelectionByBusinessCharacterCode, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set SelectionByBusinessCharacterCode value
     * @throws \InvalidArgumentException
     * @param \StructType\CustomerSelectionByBusinessCharacterCode[] $selectionByBusinessCharacterCode
     * @return \StructType\CustomerSelectionByCommunicationData
     */
    public function setSelectionByBusinessCharacterCode(array $selectionByBusinessCharacterCode = array())
    {
        // validation for constraint: array
        if ('' !== ($selectionByBusinessCharacterCodeArrayErrorMessage = self::validateSelectionByBusinessCharacterCodeForArrayConstraintsFromSetSelectionByBusinessCharacterCode($selectionByBusinessCharacterCode))) {
            throw new \InvalidArgumentException($selectionByBusinessCharacterCodeArrayErrorMessage, __LINE__);
        }
        $this->SelectionByBusinessCharacterCode = $selectionByBusinessCharacterCode;
        return $this;
    }
    /**
     * Add item to SelectionByBusinessCharacterCode value
     * @throws \InvalidArgumentException
     * @param \StructType\CustomerSelectionByBusinessCharacterCode $item
     * @return \StructType\CustomerSelectionByCommunicationData
     */
    public function addToSelectionByBusinessCharacterCode(\StructType\CustomerSelectionByBusinessCharacterCode $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\CustomerSelectionByBusinessCharacterCode) {
            throw new \InvalidArgumentException(sprintf('The SelectionByBusinessCharacterCode property can only contain items of type \StructType\CustomerSelectionByBusinessCharacterCode, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->SelectionByBusinessCharacterCode[] = $item;
        return $this;
    }
    /**
     * Get SelectionByBusinessPartnerName value
     * @return \StructType\CustomerSelectionByBusinessPartnerName[]|null
     */
    public function getSelectionByBusinessPartnerName()
    {
        return $this->SelectionByBusinessPartnerName;
    }
    /**
     * This method is responsible for validating the values passed to the setSelectionByBusinessPartnerName method
     * This method is willingly generated in order to preserve the one-line inline validation within the setSelectionByBusinessPartnerName method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateSelectionByBusinessPartnerNameForArrayConstraintsFromSetSelectionByBusinessPartnerName(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $customerSelectionByCommunicationDataSelectionByBusinessPartnerNameItem) {
            // validation for constraint: itemType
            if (!$customerSelectionByCommunicationDataSelectionByBusinessPartnerNameItem instanceof \StructType\CustomerSelectionByBusinessPartnerName) {
                $invalidValues[] = is_object($customerSelectionByCommunicationDataSelectionByBusinessPartnerNameItem) ? get_class($customerSelectionByCommunicationDataSelectionByBusinessPartnerNameItem) : sprintf('%s(%s)', gettype($customerSelectionByCommunicationDataSelectionByBusinessPartnerNameItem), var_export($customerSelectionByCommunicationDataSelectionByBusinessPartnerNameItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The SelectionByBusinessPartnerName property can only contain items of type \StructType\CustomerSelectionByBusinessPartnerName, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set SelectionByBusinessPartnerName value
     * @throws \InvalidArgumentException
     * @param \StructType\CustomerSelectionByBusinessPartnerName[] $selectionByBusinessPartnerName
     * @return \StructType\CustomerSelectionByCommunicationData
     */
    public function setSelectionByBusinessPartnerName(array $selectionByBusinessPartnerName = array())
    {
        // validation for constraint: array
        if ('' !== ($selectionByBusinessPartnerNameArrayErrorMessage = self::validateSelectionByBusinessPartnerNameForArrayConstraintsFromSetSelectionByBusinessPartnerName($selectionByBusinessPartnerName))) {
            throw new \InvalidArgumentException($selectionByBusinessPartnerNameArrayErrorMessage, __LINE__);
        }
        $this->SelectionByBusinessPartnerName = $selectionByBusinessPartnerName;
        return $this;
    }
    /**
     * Add item to SelectionByBusinessPartnerName value
     * @throws \InvalidArgumentException
     * @param \StructType\CustomerSelectionByBusinessPartnerName $item
     * @return \StructType\CustomerSelectionByCommunicationData
     */
    public function addToSelectionByBusinessPartnerName(\StructType\CustomerSelectionByBusinessPartnerName $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\CustomerSelectionByBusinessPartnerName) {
            throw new \InvalidArgumentException(sprintf('The SelectionByBusinessPartnerName property can only contain items of type \StructType\CustomerSelectionByBusinessPartnerName, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->SelectionByBusinessPartnerName[] = $item;
        return $this;
    }
    /**
     * Get SelectionByBusinessPartnerAdditionalName value
     * @return \StructType\CustomerSelectionByBusinessPartnerAdditionalName[]|null
     */
    public function getSelectionByBusinessPartnerAdditionalName()
    {
        return $this->SelectionByBusinessPartnerAdditionalName;
    }
    /**
     * This method is responsible for validating the values passed to the setSelectionByBusinessPartnerAdditionalName method
     * This method is willingly generated in order to preserve the one-line inline validation within the setSelectionByBusinessPartnerAdditionalName method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateSelectionByBusinessPartnerAdditionalNameForArrayConstraintsFromSetSelectionByBusinessPartnerAdditionalName(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $customerSelectionByCommunicationDataSelectionByBusinessPartnerAdditionalNameItem) {
            // validation for constraint: itemType
            if (!$customerSelectionByCommunicationDataSelectionByBusinessPartnerAdditionalNameItem instanceof \StructType\CustomerSelectionByBusinessPartnerAdditionalName) {
                $invalidValues[] = is_object($customerSelectionByCommunicationDataSelectionByBusinessPartnerAdditionalNameItem) ? get_class($customerSelectionByCommunicationDataSelectionByBusinessPartnerAdditionalNameItem) : sprintf('%s(%s)', gettype($customerSelectionByCommunicationDataSelectionByBusinessPartnerAdditionalNameItem), var_export($customerSelectionByCommunicationDataSelectionByBusinessPartnerAdditionalNameItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The SelectionByBusinessPartnerAdditionalName property can only contain items of type \StructType\CustomerSelectionByBusinessPartnerAdditionalName, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set SelectionByBusinessPartnerAdditionalName value
     * @throws \InvalidArgumentException
     * @param \StructType\CustomerSelectionByBusinessPartnerAdditionalName[] $selectionByBusinessPartnerAdditionalName
     * @return \StructType\CustomerSelectionByCommunicationData
     */
    public function setSelectionByBusinessPartnerAdditionalName(array $selectionByBusinessPartnerAdditionalName = array())
    {
        // validation for constraint: array
        if ('' !== ($selectionByBusinessPartnerAdditionalNameArrayErrorMessage = self::validateSelectionByBusinessPartnerAdditionalNameForArrayConstraintsFromSetSelectionByBusinessPartnerAdditionalName($selectionByBusinessPartnerAdditionalName))) {
            throw new \InvalidArgumentException($selectionByBusinessPartnerAdditionalNameArrayErrorMessage, __LINE__);
        }
        $this->SelectionByBusinessPartnerAdditionalName = $selectionByBusinessPartnerAdditionalName;
        return $this;
    }
    /**
     * Add item to SelectionByBusinessPartnerAdditionalName value
     * @throws \InvalidArgumentException
     * @param \StructType\CustomerSelectionByBusinessPartnerAdditionalName $item
     * @return \StructType\CustomerSelectionByCommunicationData
     */
    public function addToSelectionByBusinessPartnerAdditionalName(\StructType\CustomerSelectionByBusinessPartnerAdditionalName $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\CustomerSelectionByBusinessPartnerAdditionalName) {
            throw new \InvalidArgumentException(sprintf('The SelectionByBusinessPartnerAdditionalName property can only contain items of type \StructType\CustomerSelectionByBusinessPartnerAdditionalName, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->SelectionByBusinessPartnerAdditionalName[] = $item;
        return $this;
    }
    /**
     * Get SelectionBySortingFormattedName value
     * @return \StructType\CustomerSelectionBySortingFormattedName[]|null
     */
    public function getSelectionBySortingFormattedName()
    {
        return $this->SelectionBySortingFormattedName;
    }
    /**
     * This method is responsible for validating the values passed to the setSelectionBySortingFormattedName method
     * This method is willingly generated in order to preserve the one-line inline validation within the setSelectionBySortingFormattedName method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateSelectionBySortingFormattedNameForArrayConstraintsFromSetSelectionBySortingFormattedName(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $customerSelectionByCommunicationDataSelectionBySortingFormattedNameItem) {
            // validation for constraint: itemType
            if (!$customerSelectionByCommunicationDataSelectionBySortingFormattedNameItem instanceof \StructType\CustomerSelectionBySortingFormattedName) {
                $invalidValues[] = is_object($customerSelectionByCommunicationDataSelectionBySortingFormattedNameItem) ? get_class($customerSelectionByCommunicationDataSelectionBySortingFormattedNameItem) : sprintf('%s(%s)', gettype($customerSelectionByCommunicationDataSelectionBySortingFormattedNameItem), var_export($customerSelectionByCommunicationDataSelectionBySortingFormattedNameItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The SelectionBySortingFormattedName property can only contain items of type \StructType\CustomerSelectionBySortingFormattedName, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set SelectionBySortingFormattedName value
     * @throws \InvalidArgumentException
     * @param \StructType\CustomerSelectionBySortingFormattedName[] $selectionBySortingFormattedName
     * @return \StructType\CustomerSelectionByCommunicationData
     */
    public function setSelectionBySortingFormattedName(array $selectionBySortingFormattedName = array())
    {
        // validation for constraint: array
        if ('' !== ($selectionBySortingFormattedNameArrayErrorMessage = self::validateSelectionBySortingFormattedNameForArrayConstraintsFromSetSelectionBySortingFormattedName($selectionBySortingFormattedName))) {
            throw new \InvalidArgumentException($selectionBySortingFormattedNameArrayErrorMessage, __LINE__);
        }
        $this->SelectionBySortingFormattedName = $selectionBySortingFormattedName;
        return $this;
    }
    /**
     * Add item to SelectionBySortingFormattedName value
     * @throws \InvalidArgumentException
     * @param \StructType\CustomerSelectionBySortingFormattedName $item
     * @return \StructType\CustomerSelectionByCommunicationData
     */
    public function addToSelectionBySortingFormattedName(\StructType\CustomerSelectionBySortingFormattedName $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\CustomerSelectionBySortingFormattedName) {
            throw new \InvalidArgumentException(sprintf('The SelectionBySortingFormattedName property can only contain items of type \StructType\CustomerSelectionBySortingFormattedName, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->SelectionBySortingFormattedName[] = $item;
        return $this;
    }
    /**
     * Get SelectionByLifeCycleStatusCode value
     * @return \StructType\CustomerSelectionByLifeCycleStatusCode[]|null
     */
    public function getSelectionByLifeCycleStatusCode()
    {
        return $this->SelectionByLifeCycleStatusCode;
    }
    /**
     * This method is responsible for validating the values passed to the setSelectionByLifeCycleStatusCode method
     * This method is willingly generated in order to preserve the one-line inline validation within the setSelectionByLifeCycleStatusCode method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateSelectionByLifeCycleStatusCodeForArrayConstraintsFromSetSelectionByLifeCycleStatusCode(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $customerSelectionByCommunicationDataSelectionByLifeCycleStatusCodeItem) {
            // validation for constraint: itemType
            if (!$customerSelectionByCommunicationDataSelectionByLifeCycleStatusCodeItem instanceof \StructType\CustomerSelectionByLifeCycleStatusCode) {
                $invalidValues[] = is_object($customerSelectionByCommunicationDataSelectionByLifeCycleStatusCodeItem) ? get_class($customerSelectionByCommunicationDataSelectionByLifeCycleStatusCodeItem) : sprintf('%s(%s)', gettype($customerSelectionByCommunicationDataSelectionByLifeCycleStatusCodeItem), var_export($customerSelectionByCommunicationDataSelectionByLifeCycleStatusCodeItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The SelectionByLifeCycleStatusCode property can only contain items of type \StructType\CustomerSelectionByLifeCycleStatusCode, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set SelectionByLifeCycleStatusCode value
     * @throws \InvalidArgumentException
     * @param \StructType\CustomerSelectionByLifeCycleStatusCode[] $selectionByLifeCycleStatusCode
     * @return \StructType\CustomerSelectionByCommunicationData
     */
    public function setSelectionByLifeCycleStatusCode(array $selectionByLifeCycleStatusCode = array())
    {
        // validation for constraint: array
        if ('' !== ($selectionByLifeCycleStatusCodeArrayErrorMessage = self::validateSelectionByLifeCycleStatusCodeForArrayConstraintsFromSetSelectionByLifeCycleStatusCode($selectionByLifeCycleStatusCode))) {
            throw new \InvalidArgumentException($selectionByLifeCycleStatusCodeArrayErrorMessage, __LINE__);
        }
        $this->SelectionByLifeCycleStatusCode = $selectionByLifeCycleStatusCode;
        return $this;
    }
    /**
     * Add item to SelectionByLifeCycleStatusCode value
     * @throws \InvalidArgumentException
     * @param \StructType\CustomerSelectionByLifeCycleStatusCode $item
     * @return \StructType\CustomerSelectionByCommunicationData
     */
    public function addToSelectionByLifeCycleStatusCode(\StructType\CustomerSelectionByLifeCycleStatusCode $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\CustomerSelectionByLifeCycleStatusCode) {
            throw new \InvalidArgumentException(sprintf('The SelectionByLifeCycleStatusCode property can only contain items of type \StructType\CustomerSelectionByLifeCycleStatusCode, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->SelectionByLifeCycleStatusCode[] = $item;
        return $this;
    }
    /**
     * Get SelectionBySearchText value
     * @return string|null
     */
    public function getSelectionBySearchText()
    {
        return $this->SelectionBySearchText;
    }
    /**
     * Set SelectionBySearchText value
     * @param string $selectionBySearchText
     * @return \StructType\CustomerSelectionByCommunicationData
     */
    public function setSelectionBySearchText($selectionBySearchText = null)
    {
        // validation for constraint: string
        if (!is_null($selectionBySearchText) && !is_string($selectionBySearchText)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($selectionBySearchText, true), gettype($selectionBySearchText)), __LINE__);
        }
        $this->SelectionBySearchText = $selectionBySearchText;
        return $this;
    }
}
