<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CustomerSelectionByIdentification StructType
 * @subpackage Structs
 */
class CustomerSelectionByIdentification extends AbstractStructBase
{
    /**
     * The SelectionByInternalID
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\CustomerSelectionByInternalID[]
     */
    public $SelectionByInternalID;
    /**
     * The SelectionByUUID
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\CustomerSelectionByUUID[]
     */
    public $SelectionByUUID;
    /**
     * The SelectionByCategoryCode
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\CustomerSelectionByCategoryCode[]
     */
    public $SelectionByCategoryCode;
    /**
     * The SelectionByBusinessPartnerID
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\CustomerSelectionByBusinessPartnerID[]
     */
    public $SelectionByBusinessPartnerID;
    /**
     * The SelectionByPartyIdentifierTypeCode
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\CustomerSelectionByPartyIdentifierTypeCode[]
     */
    public $SelectionByPartyIdentifierTypeCode;
    /**
     * The SelectionByBusinessPartnerName
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\CustomerSelectionByBusinessPartnerName[]
     */
    public $SelectionByBusinessPartnerName;
    /**
     * The SelectionByBusinessPartnerAdditionalName
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\CustomerSelectionByBusinessPartnerAdditionalName[]
     */
    public $SelectionByBusinessPartnerAdditionalName;
    /**
     * The SelectionBySortingFormattedName
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\CustomerSelectionBySortingFormattedName[]
     */
    public $SelectionBySortingFormattedName;
    /**
     * The SelectionByLifeCycleStatusCode
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\CustomerSelectionByLifeCycleStatusCode[]
     */
    public $SelectionByLifeCycleStatusCode;
    /**
     * The SelectionBySearchText
     * Meta information extracted from the WSDL
     * - documentation: Text
     * - base: xsd:string
     * - minOccurs: 0
     * @var string
     */
    public $SelectionBySearchText;
    /**
     * Constructor method for CustomerSelectionByIdentification
     * @uses CustomerSelectionByIdentification::setSelectionByInternalID()
     * @uses CustomerSelectionByIdentification::setSelectionByUUID()
     * @uses CustomerSelectionByIdentification::setSelectionByCategoryCode()
     * @uses CustomerSelectionByIdentification::setSelectionByBusinessPartnerID()
     * @uses CustomerSelectionByIdentification::setSelectionByPartyIdentifierTypeCode()
     * @uses CustomerSelectionByIdentification::setSelectionByBusinessPartnerName()
     * @uses CustomerSelectionByIdentification::setSelectionByBusinessPartnerAdditionalName()
     * @uses CustomerSelectionByIdentification::setSelectionBySortingFormattedName()
     * @uses CustomerSelectionByIdentification::setSelectionByLifeCycleStatusCode()
     * @uses CustomerSelectionByIdentification::setSelectionBySearchText()
     * @param \StructType\CustomerSelectionByInternalID[] $selectionByInternalID
     * @param \StructType\CustomerSelectionByUUID[] $selectionByUUID
     * @param \StructType\CustomerSelectionByCategoryCode[] $selectionByCategoryCode
     * @param \StructType\CustomerSelectionByBusinessPartnerID[] $selectionByBusinessPartnerID
     * @param \StructType\CustomerSelectionByPartyIdentifierTypeCode[] $selectionByPartyIdentifierTypeCode
     * @param \StructType\CustomerSelectionByBusinessPartnerName[] $selectionByBusinessPartnerName
     * @param \StructType\CustomerSelectionByBusinessPartnerAdditionalName[] $selectionByBusinessPartnerAdditionalName
     * @param \StructType\CustomerSelectionBySortingFormattedName[] $selectionBySortingFormattedName
     * @param \StructType\CustomerSelectionByLifeCycleStatusCode[] $selectionByLifeCycleStatusCode
     * @param string $selectionBySearchText
     */
    public function __construct(array $selectionByInternalID = array(), array $selectionByUUID = array(), array $selectionByCategoryCode = array(), array $selectionByBusinessPartnerID = array(), array $selectionByPartyIdentifierTypeCode = array(), array $selectionByBusinessPartnerName = array(), array $selectionByBusinessPartnerAdditionalName = array(), array $selectionBySortingFormattedName = array(), array $selectionByLifeCycleStatusCode = array(), $selectionBySearchText = null)
    {
        $this
            ->setSelectionByInternalID($selectionByInternalID)
            ->setSelectionByUUID($selectionByUUID)
            ->setSelectionByCategoryCode($selectionByCategoryCode)
            ->setSelectionByBusinessPartnerID($selectionByBusinessPartnerID)
            ->setSelectionByPartyIdentifierTypeCode($selectionByPartyIdentifierTypeCode)
            ->setSelectionByBusinessPartnerName($selectionByBusinessPartnerName)
            ->setSelectionByBusinessPartnerAdditionalName($selectionByBusinessPartnerAdditionalName)
            ->setSelectionBySortingFormattedName($selectionBySortingFormattedName)
            ->setSelectionByLifeCycleStatusCode($selectionByLifeCycleStatusCode)
            ->setSelectionBySearchText($selectionBySearchText);
    }
    /**
     * Get SelectionByInternalID value
     * @return \StructType\CustomerSelectionByInternalID[]|null
     */
    public function getSelectionByInternalID()
    {
        return $this->SelectionByInternalID;
    }
    /**
     * This method is responsible for validating the values passed to the setSelectionByInternalID method
     * This method is willingly generated in order to preserve the one-line inline validation within the setSelectionByInternalID method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateSelectionByInternalIDForArrayConstraintsFromSetSelectionByInternalID(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $customerSelectionByIdentificationSelectionByInternalIDItem) {
            // validation for constraint: itemType
            if (!$customerSelectionByIdentificationSelectionByInternalIDItem instanceof \StructType\CustomerSelectionByInternalID) {
                $invalidValues[] = is_object($customerSelectionByIdentificationSelectionByInternalIDItem) ? get_class($customerSelectionByIdentificationSelectionByInternalIDItem) : sprintf('%s(%s)', gettype($customerSelectionByIdentificationSelectionByInternalIDItem), var_export($customerSelectionByIdentificationSelectionByInternalIDItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The SelectionByInternalID property can only contain items of type \StructType\CustomerSelectionByInternalID, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set SelectionByInternalID value
     * @throws \InvalidArgumentException
     * @param \StructType\CustomerSelectionByInternalID[] $selectionByInternalID
     * @return \StructType\CustomerSelectionByIdentification
     */
    public function setSelectionByInternalID(array $selectionByInternalID = array())
    {
        // validation for constraint: array
        if ('' !== ($selectionByInternalIDArrayErrorMessage = self::validateSelectionByInternalIDForArrayConstraintsFromSetSelectionByInternalID($selectionByInternalID))) {
            throw new \InvalidArgumentException($selectionByInternalIDArrayErrorMessage, __LINE__);
        }
        $this->SelectionByInternalID = $selectionByInternalID;
        return $this;
    }
    /**
     * Add item to SelectionByInternalID value
     * @throws \InvalidArgumentException
     * @param \StructType\CustomerSelectionByInternalID $item
     * @return \StructType\CustomerSelectionByIdentification
     */
    public function addToSelectionByInternalID(\StructType\CustomerSelectionByInternalID $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\CustomerSelectionByInternalID) {
            throw new \InvalidArgumentException(sprintf('The SelectionByInternalID property can only contain items of type \StructType\CustomerSelectionByInternalID, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->SelectionByInternalID[] = $item;
        return $this;
    }
    /**
     * Get SelectionByUUID value
     * @return \StructType\CustomerSelectionByUUID[]|null
     */
    public function getSelectionByUUID()
    {
        return $this->SelectionByUUID;
    }
    /**
     * This method is responsible for validating the values passed to the setSelectionByUUID method
     * This method is willingly generated in order to preserve the one-line inline validation within the setSelectionByUUID method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateSelectionByUUIDForArrayConstraintsFromSetSelectionByUUID(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $customerSelectionByIdentificationSelectionByUUIDItem) {
            // validation for constraint: itemType
            if (!$customerSelectionByIdentificationSelectionByUUIDItem instanceof \StructType\CustomerSelectionByUUID) {
                $invalidValues[] = is_object($customerSelectionByIdentificationSelectionByUUIDItem) ? get_class($customerSelectionByIdentificationSelectionByUUIDItem) : sprintf('%s(%s)', gettype($customerSelectionByIdentificationSelectionByUUIDItem), var_export($customerSelectionByIdentificationSelectionByUUIDItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The SelectionByUUID property can only contain items of type \StructType\CustomerSelectionByUUID, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set SelectionByUUID value
     * @throws \InvalidArgumentException
     * @param \StructType\CustomerSelectionByUUID[] $selectionByUUID
     * @return \StructType\CustomerSelectionByIdentification
     */
    public function setSelectionByUUID(array $selectionByUUID = array())
    {
        // validation for constraint: array
        if ('' !== ($selectionByUUIDArrayErrorMessage = self::validateSelectionByUUIDForArrayConstraintsFromSetSelectionByUUID($selectionByUUID))) {
            throw new \InvalidArgumentException($selectionByUUIDArrayErrorMessage, __LINE__);
        }
        $this->SelectionByUUID = $selectionByUUID;
        return $this;
    }
    /**
     * Add item to SelectionByUUID value
     * @throws \InvalidArgumentException
     * @param \StructType\CustomerSelectionByUUID $item
     * @return \StructType\CustomerSelectionByIdentification
     */
    public function addToSelectionByUUID(\StructType\CustomerSelectionByUUID $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\CustomerSelectionByUUID) {
            throw new \InvalidArgumentException(sprintf('The SelectionByUUID property can only contain items of type \StructType\CustomerSelectionByUUID, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->SelectionByUUID[] = $item;
        return $this;
    }
    /**
     * Get SelectionByCategoryCode value
     * @return \StructType\CustomerSelectionByCategoryCode[]|null
     */
    public function getSelectionByCategoryCode()
    {
        return $this->SelectionByCategoryCode;
    }
    /**
     * This method is responsible for validating the values passed to the setSelectionByCategoryCode method
     * This method is willingly generated in order to preserve the one-line inline validation within the setSelectionByCategoryCode method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateSelectionByCategoryCodeForArrayConstraintsFromSetSelectionByCategoryCode(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $customerSelectionByIdentificationSelectionByCategoryCodeItem) {
            // validation for constraint: itemType
            if (!$customerSelectionByIdentificationSelectionByCategoryCodeItem instanceof \StructType\CustomerSelectionByCategoryCode) {
                $invalidValues[] = is_object($customerSelectionByIdentificationSelectionByCategoryCodeItem) ? get_class($customerSelectionByIdentificationSelectionByCategoryCodeItem) : sprintf('%s(%s)', gettype($customerSelectionByIdentificationSelectionByCategoryCodeItem), var_export($customerSelectionByIdentificationSelectionByCategoryCodeItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The SelectionByCategoryCode property can only contain items of type \StructType\CustomerSelectionByCategoryCode, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set SelectionByCategoryCode value
     * @throws \InvalidArgumentException
     * @param \StructType\CustomerSelectionByCategoryCode[] $selectionByCategoryCode
     * @return \StructType\CustomerSelectionByIdentification
     */
    public function setSelectionByCategoryCode(array $selectionByCategoryCode = array())
    {
        // validation for constraint: array
        if ('' !== ($selectionByCategoryCodeArrayErrorMessage = self::validateSelectionByCategoryCodeForArrayConstraintsFromSetSelectionByCategoryCode($selectionByCategoryCode))) {
            throw new \InvalidArgumentException($selectionByCategoryCodeArrayErrorMessage, __LINE__);
        }
        $this->SelectionByCategoryCode = $selectionByCategoryCode;
        return $this;
    }
    /**
     * Add item to SelectionByCategoryCode value
     * @throws \InvalidArgumentException
     * @param \StructType\CustomerSelectionByCategoryCode $item
     * @return \StructType\CustomerSelectionByIdentification
     */
    public function addToSelectionByCategoryCode(\StructType\CustomerSelectionByCategoryCode $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\CustomerSelectionByCategoryCode) {
            throw new \InvalidArgumentException(sprintf('The SelectionByCategoryCode property can only contain items of type \StructType\CustomerSelectionByCategoryCode, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->SelectionByCategoryCode[] = $item;
        return $this;
    }
    /**
     * Get SelectionByBusinessPartnerID value
     * @return \StructType\CustomerSelectionByBusinessPartnerID[]|null
     */
    public function getSelectionByBusinessPartnerID()
    {
        return $this->SelectionByBusinessPartnerID;
    }
    /**
     * This method is responsible for validating the values passed to the setSelectionByBusinessPartnerID method
     * This method is willingly generated in order to preserve the one-line inline validation within the setSelectionByBusinessPartnerID method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateSelectionByBusinessPartnerIDForArrayConstraintsFromSetSelectionByBusinessPartnerID(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $customerSelectionByIdentificationSelectionByBusinessPartnerIDItem) {
            // validation for constraint: itemType
            if (!$customerSelectionByIdentificationSelectionByBusinessPartnerIDItem instanceof \StructType\CustomerSelectionByBusinessPartnerID) {
                $invalidValues[] = is_object($customerSelectionByIdentificationSelectionByBusinessPartnerIDItem) ? get_class($customerSelectionByIdentificationSelectionByBusinessPartnerIDItem) : sprintf('%s(%s)', gettype($customerSelectionByIdentificationSelectionByBusinessPartnerIDItem), var_export($customerSelectionByIdentificationSelectionByBusinessPartnerIDItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The SelectionByBusinessPartnerID property can only contain items of type \StructType\CustomerSelectionByBusinessPartnerID, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set SelectionByBusinessPartnerID value
     * @throws \InvalidArgumentException
     * @param \StructType\CustomerSelectionByBusinessPartnerID[] $selectionByBusinessPartnerID
     * @return \StructType\CustomerSelectionByIdentification
     */
    public function setSelectionByBusinessPartnerID(array $selectionByBusinessPartnerID = array())
    {
        // validation for constraint: array
        if ('' !== ($selectionByBusinessPartnerIDArrayErrorMessage = self::validateSelectionByBusinessPartnerIDForArrayConstraintsFromSetSelectionByBusinessPartnerID($selectionByBusinessPartnerID))) {
            throw new \InvalidArgumentException($selectionByBusinessPartnerIDArrayErrorMessage, __LINE__);
        }
        $this->SelectionByBusinessPartnerID = $selectionByBusinessPartnerID;
        return $this;
    }
    /**
     * Add item to SelectionByBusinessPartnerID value
     * @throws \InvalidArgumentException
     * @param \StructType\CustomerSelectionByBusinessPartnerID $item
     * @return \StructType\CustomerSelectionByIdentification
     */
    public function addToSelectionByBusinessPartnerID(\StructType\CustomerSelectionByBusinessPartnerID $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\CustomerSelectionByBusinessPartnerID) {
            throw new \InvalidArgumentException(sprintf('The SelectionByBusinessPartnerID property can only contain items of type \StructType\CustomerSelectionByBusinessPartnerID, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->SelectionByBusinessPartnerID[] = $item;
        return $this;
    }
    /**
     * Get SelectionByPartyIdentifierTypeCode value
     * @return \StructType\CustomerSelectionByPartyIdentifierTypeCode[]|null
     */
    public function getSelectionByPartyIdentifierTypeCode()
    {
        return $this->SelectionByPartyIdentifierTypeCode;
    }
    /**
     * This method is responsible for validating the values passed to the setSelectionByPartyIdentifierTypeCode method
     * This method is willingly generated in order to preserve the one-line inline validation within the setSelectionByPartyIdentifierTypeCode method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateSelectionByPartyIdentifierTypeCodeForArrayConstraintsFromSetSelectionByPartyIdentifierTypeCode(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $customerSelectionByIdentificationSelectionByPartyIdentifierTypeCodeItem) {
            // validation for constraint: itemType
            if (!$customerSelectionByIdentificationSelectionByPartyIdentifierTypeCodeItem instanceof \StructType\CustomerSelectionByPartyIdentifierTypeCode) {
                $invalidValues[] = is_object($customerSelectionByIdentificationSelectionByPartyIdentifierTypeCodeItem) ? get_class($customerSelectionByIdentificationSelectionByPartyIdentifierTypeCodeItem) : sprintf('%s(%s)', gettype($customerSelectionByIdentificationSelectionByPartyIdentifierTypeCodeItem), var_export($customerSelectionByIdentificationSelectionByPartyIdentifierTypeCodeItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The SelectionByPartyIdentifierTypeCode property can only contain items of type \StructType\CustomerSelectionByPartyIdentifierTypeCode, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set SelectionByPartyIdentifierTypeCode value
     * @throws \InvalidArgumentException
     * @param \StructType\CustomerSelectionByPartyIdentifierTypeCode[] $selectionByPartyIdentifierTypeCode
     * @return \StructType\CustomerSelectionByIdentification
     */
    public function setSelectionByPartyIdentifierTypeCode(array $selectionByPartyIdentifierTypeCode = array())
    {
        // validation for constraint: array
        if ('' !== ($selectionByPartyIdentifierTypeCodeArrayErrorMessage = self::validateSelectionByPartyIdentifierTypeCodeForArrayConstraintsFromSetSelectionByPartyIdentifierTypeCode($selectionByPartyIdentifierTypeCode))) {
            throw new \InvalidArgumentException($selectionByPartyIdentifierTypeCodeArrayErrorMessage, __LINE__);
        }
        $this->SelectionByPartyIdentifierTypeCode = $selectionByPartyIdentifierTypeCode;
        return $this;
    }
    /**
     * Add item to SelectionByPartyIdentifierTypeCode value
     * @throws \InvalidArgumentException
     * @param \StructType\CustomerSelectionByPartyIdentifierTypeCode $item
     * @return \StructType\CustomerSelectionByIdentification
     */
    public function addToSelectionByPartyIdentifierTypeCode(\StructType\CustomerSelectionByPartyIdentifierTypeCode $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\CustomerSelectionByPartyIdentifierTypeCode) {
            throw new \InvalidArgumentException(sprintf('The SelectionByPartyIdentifierTypeCode property can only contain items of type \StructType\CustomerSelectionByPartyIdentifierTypeCode, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->SelectionByPartyIdentifierTypeCode[] = $item;
        return $this;
    }
    /**
     * Get SelectionByBusinessPartnerName value
     * @return \StructType\CustomerSelectionByBusinessPartnerName[]|null
     */
    public function getSelectionByBusinessPartnerName()
    {
        return $this->SelectionByBusinessPartnerName;
    }
    /**
     * This method is responsible for validating the values passed to the setSelectionByBusinessPartnerName method
     * This method is willingly generated in order to preserve the one-line inline validation within the setSelectionByBusinessPartnerName method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateSelectionByBusinessPartnerNameForArrayConstraintsFromSetSelectionByBusinessPartnerName(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $customerSelectionByIdentificationSelectionByBusinessPartnerNameItem) {
            // validation for constraint: itemType
            if (!$customerSelectionByIdentificationSelectionByBusinessPartnerNameItem instanceof \StructType\CustomerSelectionByBusinessPartnerName) {
                $invalidValues[] = is_object($customerSelectionByIdentificationSelectionByBusinessPartnerNameItem) ? get_class($customerSelectionByIdentificationSelectionByBusinessPartnerNameItem) : sprintf('%s(%s)', gettype($customerSelectionByIdentificationSelectionByBusinessPartnerNameItem), var_export($customerSelectionByIdentificationSelectionByBusinessPartnerNameItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The SelectionByBusinessPartnerName property can only contain items of type \StructType\CustomerSelectionByBusinessPartnerName, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set SelectionByBusinessPartnerName value
     * @throws \InvalidArgumentException
     * @param \StructType\CustomerSelectionByBusinessPartnerName[] $selectionByBusinessPartnerName
     * @return \StructType\CustomerSelectionByIdentification
     */
    public function setSelectionByBusinessPartnerName(array $selectionByBusinessPartnerName = array())
    {
        // validation for constraint: array
        if ('' !== ($selectionByBusinessPartnerNameArrayErrorMessage = self::validateSelectionByBusinessPartnerNameForArrayConstraintsFromSetSelectionByBusinessPartnerName($selectionByBusinessPartnerName))) {
            throw new \InvalidArgumentException($selectionByBusinessPartnerNameArrayErrorMessage, __LINE__);
        }
        $this->SelectionByBusinessPartnerName = $selectionByBusinessPartnerName;
        return $this;
    }
    /**
     * Add item to SelectionByBusinessPartnerName value
     * @throws \InvalidArgumentException
     * @param \StructType\CustomerSelectionByBusinessPartnerName $item
     * @return \StructType\CustomerSelectionByIdentification
     */
    public function addToSelectionByBusinessPartnerName(\StructType\CustomerSelectionByBusinessPartnerName $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\CustomerSelectionByBusinessPartnerName) {
            throw new \InvalidArgumentException(sprintf('The SelectionByBusinessPartnerName property can only contain items of type \StructType\CustomerSelectionByBusinessPartnerName, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->SelectionByBusinessPartnerName[] = $item;
        return $this;
    }
    /**
     * Get SelectionByBusinessPartnerAdditionalName value
     * @return \StructType\CustomerSelectionByBusinessPartnerAdditionalName[]|null
     */
    public function getSelectionByBusinessPartnerAdditionalName()
    {
        return $this->SelectionByBusinessPartnerAdditionalName;
    }
    /**
     * This method is responsible for validating the values passed to the setSelectionByBusinessPartnerAdditionalName method
     * This method is willingly generated in order to preserve the one-line inline validation within the setSelectionByBusinessPartnerAdditionalName method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateSelectionByBusinessPartnerAdditionalNameForArrayConstraintsFromSetSelectionByBusinessPartnerAdditionalName(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $customerSelectionByIdentificationSelectionByBusinessPartnerAdditionalNameItem) {
            // validation for constraint: itemType
            if (!$customerSelectionByIdentificationSelectionByBusinessPartnerAdditionalNameItem instanceof \StructType\CustomerSelectionByBusinessPartnerAdditionalName) {
                $invalidValues[] = is_object($customerSelectionByIdentificationSelectionByBusinessPartnerAdditionalNameItem) ? get_class($customerSelectionByIdentificationSelectionByBusinessPartnerAdditionalNameItem) : sprintf('%s(%s)', gettype($customerSelectionByIdentificationSelectionByBusinessPartnerAdditionalNameItem), var_export($customerSelectionByIdentificationSelectionByBusinessPartnerAdditionalNameItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The SelectionByBusinessPartnerAdditionalName property can only contain items of type \StructType\CustomerSelectionByBusinessPartnerAdditionalName, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set SelectionByBusinessPartnerAdditionalName value
     * @throws \InvalidArgumentException
     * @param \StructType\CustomerSelectionByBusinessPartnerAdditionalName[] $selectionByBusinessPartnerAdditionalName
     * @return \StructType\CustomerSelectionByIdentification
     */
    public function setSelectionByBusinessPartnerAdditionalName(array $selectionByBusinessPartnerAdditionalName = array())
    {
        // validation for constraint: array
        if ('' !== ($selectionByBusinessPartnerAdditionalNameArrayErrorMessage = self::validateSelectionByBusinessPartnerAdditionalNameForArrayConstraintsFromSetSelectionByBusinessPartnerAdditionalName($selectionByBusinessPartnerAdditionalName))) {
            throw new \InvalidArgumentException($selectionByBusinessPartnerAdditionalNameArrayErrorMessage, __LINE__);
        }
        $this->SelectionByBusinessPartnerAdditionalName = $selectionByBusinessPartnerAdditionalName;
        return $this;
    }
    /**
     * Add item to SelectionByBusinessPartnerAdditionalName value
     * @throws \InvalidArgumentException
     * @param \StructType\CustomerSelectionByBusinessPartnerAdditionalName $item
     * @return \StructType\CustomerSelectionByIdentification
     */
    public function addToSelectionByBusinessPartnerAdditionalName(\StructType\CustomerSelectionByBusinessPartnerAdditionalName $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\CustomerSelectionByBusinessPartnerAdditionalName) {
            throw new \InvalidArgumentException(sprintf('The SelectionByBusinessPartnerAdditionalName property can only contain items of type \StructType\CustomerSelectionByBusinessPartnerAdditionalName, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->SelectionByBusinessPartnerAdditionalName[] = $item;
        return $this;
    }
    /**
     * Get SelectionBySortingFormattedName value
     * @return \StructType\CustomerSelectionBySortingFormattedName[]|null
     */
    public function getSelectionBySortingFormattedName()
    {
        return $this->SelectionBySortingFormattedName;
    }
    /**
     * This method is responsible for validating the values passed to the setSelectionBySortingFormattedName method
     * This method is willingly generated in order to preserve the one-line inline validation within the setSelectionBySortingFormattedName method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateSelectionBySortingFormattedNameForArrayConstraintsFromSetSelectionBySortingFormattedName(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $customerSelectionByIdentificationSelectionBySortingFormattedNameItem) {
            // validation for constraint: itemType
            if (!$customerSelectionByIdentificationSelectionBySortingFormattedNameItem instanceof \StructType\CustomerSelectionBySortingFormattedName) {
                $invalidValues[] = is_object($customerSelectionByIdentificationSelectionBySortingFormattedNameItem) ? get_class($customerSelectionByIdentificationSelectionBySortingFormattedNameItem) : sprintf('%s(%s)', gettype($customerSelectionByIdentificationSelectionBySortingFormattedNameItem), var_export($customerSelectionByIdentificationSelectionBySortingFormattedNameItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The SelectionBySortingFormattedName property can only contain items of type \StructType\CustomerSelectionBySortingFormattedName, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set SelectionBySortingFormattedName value
     * @throws \InvalidArgumentException
     * @param \StructType\CustomerSelectionBySortingFormattedName[] $selectionBySortingFormattedName
     * @return \StructType\CustomerSelectionByIdentification
     */
    public function setSelectionBySortingFormattedName(array $selectionBySortingFormattedName = array())
    {
        // validation for constraint: array
        if ('' !== ($selectionBySortingFormattedNameArrayErrorMessage = self::validateSelectionBySortingFormattedNameForArrayConstraintsFromSetSelectionBySortingFormattedName($selectionBySortingFormattedName))) {
            throw new \InvalidArgumentException($selectionBySortingFormattedNameArrayErrorMessage, __LINE__);
        }
        $this->SelectionBySortingFormattedName = $selectionBySortingFormattedName;
        return $this;
    }
    /**
     * Add item to SelectionBySortingFormattedName value
     * @throws \InvalidArgumentException
     * @param \StructType\CustomerSelectionBySortingFormattedName $item
     * @return \StructType\CustomerSelectionByIdentification
     */
    public function addToSelectionBySortingFormattedName(\StructType\CustomerSelectionBySortingFormattedName $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\CustomerSelectionBySortingFormattedName) {
            throw new \InvalidArgumentException(sprintf('The SelectionBySortingFormattedName property can only contain items of type \StructType\CustomerSelectionBySortingFormattedName, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->SelectionBySortingFormattedName[] = $item;
        return $this;
    }
    /**
     * Get SelectionByLifeCycleStatusCode value
     * @return \StructType\CustomerSelectionByLifeCycleStatusCode[]|null
     */
    public function getSelectionByLifeCycleStatusCode()
    {
        return $this->SelectionByLifeCycleStatusCode;
    }
    /**
     * This method is responsible for validating the values passed to the setSelectionByLifeCycleStatusCode method
     * This method is willingly generated in order to preserve the one-line inline validation within the setSelectionByLifeCycleStatusCode method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateSelectionByLifeCycleStatusCodeForArrayConstraintsFromSetSelectionByLifeCycleStatusCode(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $customerSelectionByIdentificationSelectionByLifeCycleStatusCodeItem) {
            // validation for constraint: itemType
            if (!$customerSelectionByIdentificationSelectionByLifeCycleStatusCodeItem instanceof \StructType\CustomerSelectionByLifeCycleStatusCode) {
                $invalidValues[] = is_object($customerSelectionByIdentificationSelectionByLifeCycleStatusCodeItem) ? get_class($customerSelectionByIdentificationSelectionByLifeCycleStatusCodeItem) : sprintf('%s(%s)', gettype($customerSelectionByIdentificationSelectionByLifeCycleStatusCodeItem), var_export($customerSelectionByIdentificationSelectionByLifeCycleStatusCodeItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The SelectionByLifeCycleStatusCode property can only contain items of type \StructType\CustomerSelectionByLifeCycleStatusCode, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set SelectionByLifeCycleStatusCode value
     * @throws \InvalidArgumentException
     * @param \StructType\CustomerSelectionByLifeCycleStatusCode[] $selectionByLifeCycleStatusCode
     * @return \StructType\CustomerSelectionByIdentification
     */
    public function setSelectionByLifeCycleStatusCode(array $selectionByLifeCycleStatusCode = array())
    {
        // validation for constraint: array
        if ('' !== ($selectionByLifeCycleStatusCodeArrayErrorMessage = self::validateSelectionByLifeCycleStatusCodeForArrayConstraintsFromSetSelectionByLifeCycleStatusCode($selectionByLifeCycleStatusCode))) {
            throw new \InvalidArgumentException($selectionByLifeCycleStatusCodeArrayErrorMessage, __LINE__);
        }
        $this->SelectionByLifeCycleStatusCode = $selectionByLifeCycleStatusCode;
        return $this;
    }
    /**
     * Add item to SelectionByLifeCycleStatusCode value
     * @throws \InvalidArgumentException
     * @param \StructType\CustomerSelectionByLifeCycleStatusCode $item
     * @return \StructType\CustomerSelectionByIdentification
     */
    public function addToSelectionByLifeCycleStatusCode(\StructType\CustomerSelectionByLifeCycleStatusCode $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\CustomerSelectionByLifeCycleStatusCode) {
            throw new \InvalidArgumentException(sprintf('The SelectionByLifeCycleStatusCode property can only contain items of type \StructType\CustomerSelectionByLifeCycleStatusCode, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->SelectionByLifeCycleStatusCode[] = $item;
        return $this;
    }
    /**
     * Get SelectionBySearchText value
     * @return string|null
     */
    public function getSelectionBySearchText()
    {
        return $this->SelectionBySearchText;
    }
    /**
     * Set SelectionBySearchText value
     * @param string $selectionBySearchText
     * @return \StructType\CustomerSelectionByIdentification
     */
    public function setSelectionBySearchText($selectionBySearchText = null)
    {
        // validation for constraint: string
        if (!is_null($selectionBySearchText) && !is_string($selectionBySearchText)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($selectionBySearchText, true), gettype($selectionBySearchText)), __LINE__);
        }
        $this->SelectionBySearchText = $selectionBySearchText;
        return $this;
    }
}
