<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ExtSelectionByCode StructType
 * @subpackage Structs
 */
class ExtSelectionByCode extends AbstractStructBase
{
    /**
     * The SelectionByCode
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\SelectionByCode[]
     */
    public $SelectionByCode;
    /**
     * Constructor method for ExtSelectionByCode
     * @uses ExtSelectionByCode::setSelectionByCode()
     * @param \StructType\SelectionByCode[] $selectionByCode
     */
    public function __construct(array $selectionByCode = array())
    {
        $this
            ->setSelectionByCode($selectionByCode);
    }
    /**
     * Get SelectionByCode value
     * @return \StructType\SelectionByCode[]|null
     */
    public function getSelectionByCode()
    {
        return $this->SelectionByCode;
    }
    /**
     * This method is responsible for validating the values passed to the setSelectionByCode method
     * This method is willingly generated in order to preserve the one-line inline validation within the setSelectionByCode method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateSelectionByCodeForArrayConstraintsFromSetSelectionByCode(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $extSelectionByCodeSelectionByCodeItem) {
            // validation for constraint: itemType
            if (!$extSelectionByCodeSelectionByCodeItem instanceof \StructType\SelectionByCode) {
                $invalidValues[] = is_object($extSelectionByCodeSelectionByCodeItem) ? get_class($extSelectionByCodeSelectionByCodeItem) : sprintf('%s(%s)', gettype($extSelectionByCodeSelectionByCodeItem), var_export($extSelectionByCodeSelectionByCodeItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The SelectionByCode property can only contain items of type \StructType\SelectionByCode, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set SelectionByCode value
     * @throws \InvalidArgumentException
     * @param \StructType\SelectionByCode[] $selectionByCode
     * @return \StructType\ExtSelectionByCode
     */
    public function setSelectionByCode(array $selectionByCode = array())
    {
        // validation for constraint: array
        if ('' !== ($selectionByCodeArrayErrorMessage = self::validateSelectionByCodeForArrayConstraintsFromSetSelectionByCode($selectionByCode))) {
            throw new \InvalidArgumentException($selectionByCodeArrayErrorMessage, __LINE__);
        }
        $this->SelectionByCode = $selectionByCode;
        return $this;
    }
    /**
     * Add item to SelectionByCode value
     * @throws \InvalidArgumentException
     * @param \StructType\SelectionByCode $item
     * @return \StructType\ExtSelectionByCode
     */
    public function addToSelectionByCode(\StructType\SelectionByCode $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\SelectionByCode) {
            throw new \InvalidArgumentException(sprintf('The SelectionByCode property can only contain items of type \StructType\SelectionByCode, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->SelectionByCode[] = $item;
        return $this;
    }
}
