<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ExtSelectionByIdentifier StructType
 * @subpackage Structs
 */
class ExtSelectionByIdentifier extends AbstractStructBase
{
    /**
     * The SelectionByIdentifier
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\SelectionByIdentifier[]
     */
    public $SelectionByIdentifier;
    /**
     * Constructor method for ExtSelectionByIdentifier
     * @uses ExtSelectionByIdentifier::setSelectionByIdentifier()
     * @param \StructType\SelectionByIdentifier[] $selectionByIdentifier
     */
    public function __construct(array $selectionByIdentifier = array())
    {
        $this
            ->setSelectionByIdentifier($selectionByIdentifier);
    }
    /**
     * Get SelectionByIdentifier value
     * @return \StructType\SelectionByIdentifier[]|null
     */
    public function getSelectionByIdentifier()
    {
        return $this->SelectionByIdentifier;
    }
    /**
     * This method is responsible for validating the values passed to the setSelectionByIdentifier method
     * This method is willingly generated in order to preserve the one-line inline validation within the setSelectionByIdentifier method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateSelectionByIdentifierForArrayConstraintsFromSetSelectionByIdentifier(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $extSelectionByIdentifierSelectionByIdentifierItem) {
            // validation for constraint: itemType
            if (!$extSelectionByIdentifierSelectionByIdentifierItem instanceof \StructType\SelectionByIdentifier) {
                $invalidValues[] = is_object($extSelectionByIdentifierSelectionByIdentifierItem) ? get_class($extSelectionByIdentifierSelectionByIdentifierItem) : sprintf('%s(%s)', gettype($extSelectionByIdentifierSelectionByIdentifierItem), var_export($extSelectionByIdentifierSelectionByIdentifierItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The SelectionByIdentifier property can only contain items of type \StructType\SelectionByIdentifier, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set SelectionByIdentifier value
     * @throws \InvalidArgumentException
     * @param \StructType\SelectionByIdentifier[] $selectionByIdentifier
     * @return \StructType\ExtSelectionByIdentifier
     */
    public function setSelectionByIdentifier(array $selectionByIdentifier = array())
    {
        // validation for constraint: array
        if ('' !== ($selectionByIdentifierArrayErrorMessage = self::validateSelectionByIdentifierForArrayConstraintsFromSetSelectionByIdentifier($selectionByIdentifier))) {
            throw new \InvalidArgumentException($selectionByIdentifierArrayErrorMessage, __LINE__);
        }
        $this->SelectionByIdentifier = $selectionByIdentifier;
        return $this;
    }
    /**
     * Add item to SelectionByIdentifier value
     * @throws \InvalidArgumentException
     * @param \StructType\SelectionByIdentifier $item
     * @return \StructType\ExtSelectionByIdentifier
     */
    public function addToSelectionByIdentifier(\StructType\SelectionByIdentifier $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\SelectionByIdentifier) {
            throw new \InvalidArgumentException(sprintf('The SelectionByIdentifier property can only contain items of type \StructType\SelectionByIdentifier, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->SelectionByIdentifier[] = $item;
        return $this;
    }
}
