<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ExtSelectionByIndicator StructType
 * @subpackage Structs
 */
class ExtSelectionByIndicator extends AbstractStructBase
{
    /**
     * The SelectionByIndicator
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\SelectionByIndicator[]
     */
    public $SelectionByIndicator;
    /**
     * Constructor method for ExtSelectionByIndicator
     * @uses ExtSelectionByIndicator::setSelectionByIndicator()
     * @param \StructType\SelectionByIndicator[] $selectionByIndicator
     */
    public function __construct(array $selectionByIndicator = array())
    {
        $this
            ->setSelectionByIndicator($selectionByIndicator);
    }
    /**
     * Get SelectionByIndicator value
     * @return \StructType\SelectionByIndicator[]|null
     */
    public function getSelectionByIndicator()
    {
        return $this->SelectionByIndicator;
    }
    /**
     * This method is responsible for validating the values passed to the setSelectionByIndicator method
     * This method is willingly generated in order to preserve the one-line inline validation within the setSelectionByIndicator method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateSelectionByIndicatorForArrayConstraintsFromSetSelectionByIndicator(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $extSelectionByIndicatorSelectionByIndicatorItem) {
            // validation for constraint: itemType
            if (!$extSelectionByIndicatorSelectionByIndicatorItem instanceof \StructType\SelectionByIndicator) {
                $invalidValues[] = is_object($extSelectionByIndicatorSelectionByIndicatorItem) ? get_class($extSelectionByIndicatorSelectionByIndicatorItem) : sprintf('%s(%s)', gettype($extSelectionByIndicatorSelectionByIndicatorItem), var_export($extSelectionByIndicatorSelectionByIndicatorItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The SelectionByIndicator property can only contain items of type \StructType\SelectionByIndicator, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set SelectionByIndicator value
     * @throws \InvalidArgumentException
     * @param \StructType\SelectionByIndicator[] $selectionByIndicator
     * @return \StructType\ExtSelectionByIndicator
     */
    public function setSelectionByIndicator(array $selectionByIndicator = array())
    {
        // validation for constraint: array
        if ('' !== ($selectionByIndicatorArrayErrorMessage = self::validateSelectionByIndicatorForArrayConstraintsFromSetSelectionByIndicator($selectionByIndicator))) {
            throw new \InvalidArgumentException($selectionByIndicatorArrayErrorMessage, __LINE__);
        }
        $this->SelectionByIndicator = $selectionByIndicator;
        return $this;
    }
    /**
     * Add item to SelectionByIndicator value
     * @throws \InvalidArgumentException
     * @param \StructType\SelectionByIndicator $item
     * @return \StructType\ExtSelectionByIndicator
     */
    public function addToSelectionByIndicator(\StructType\SelectionByIndicator $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\SelectionByIndicator) {
            throw new \InvalidArgumentException(sprintf('The SelectionByIndicator property can only contain items of type \StructType\SelectionByIndicator, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->SelectionByIndicator[] = $item;
        return $this;
    }
}
