<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ExtSelectionByText StructType
 * @subpackage Structs
 */
class ExtSelectionByText extends AbstractStructBase
{
    /**
     * The SelectionByText
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\SelectionByName[]
     */
    public $SelectionByText;
    /**
     * Constructor method for ExtSelectionByText
     * @uses ExtSelectionByText::setSelectionByText()
     * @param \StructType\SelectionByName[] $selectionByText
     */
    public function __construct(array $selectionByText = array())
    {
        $this
            ->setSelectionByText($selectionByText);
    }
    /**
     * Get SelectionByText value
     * @return \StructType\SelectionByName[]|null
     */
    public function getSelectionByText()
    {
        return $this->SelectionByText;
    }
    /**
     * This method is responsible for validating the values passed to the setSelectionByText method
     * This method is willingly generated in order to preserve the one-line inline validation within the setSelectionByText method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateSelectionByTextForArrayConstraintsFromSetSelectionByText(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $extSelectionByTextSelectionByTextItem) {
            // validation for constraint: itemType
            if (!$extSelectionByTextSelectionByTextItem instanceof \StructType\SelectionByName) {
                $invalidValues[] = is_object($extSelectionByTextSelectionByTextItem) ? get_class($extSelectionByTextSelectionByTextItem) : sprintf('%s(%s)', gettype($extSelectionByTextSelectionByTextItem), var_export($extSelectionByTextSelectionByTextItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The SelectionByText property can only contain items of type \StructType\SelectionByName, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set SelectionByText value
     * @throws \InvalidArgumentException
     * @param \StructType\SelectionByName[] $selectionByText
     * @return \StructType\ExtSelectionByText
     */
    public function setSelectionByText(array $selectionByText = array())
    {
        // validation for constraint: array
        if ('' !== ($selectionByTextArrayErrorMessage = self::validateSelectionByTextForArrayConstraintsFromSetSelectionByText($selectionByText))) {
            throw new \InvalidArgumentException($selectionByTextArrayErrorMessage, __LINE__);
        }
        $this->SelectionByText = $selectionByText;
        return $this;
    }
    /**
     * Add item to SelectionByText value
     * @throws \InvalidArgumentException
     * @param \StructType\SelectionByName $item
     * @return \StructType\ExtSelectionByText
     */
    public function addToSelectionByText(\StructType\SelectionByName $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\SelectionByName) {
            throw new \InvalidArgumentException(sprintf('The SelectionByText property can only contain items of type \StructType\SelectionByName, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->SelectionByText[] = $item;
        return $this;
    }
}
