<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for LogItemNotePlaceholderSubstitutionList StructType
 * @subpackage Structs
 */
class LogItemNotePlaceholderSubstitutionList extends AbstractStructBase
{
    /**
     * The FirstPlaceholderID
     * Meta information extracted from the WSDL
     * - documentation: Identifier
     * - base: xsd:token
     * - length: 1
     * @var string
     */
    public $FirstPlaceholderID;
    /**
     * The SecondPlaceholderID
     * Meta information extracted from the WSDL
     * - documentation: Identifier
     * - base: xsd:token
     * - length: 1
     * - minOccurs: 0
     * @var string
     */
    public $SecondPlaceholderID;
    /**
     * The ThirdPlaceholderID
     * Meta information extracted from the WSDL
     * - documentation: Identifier
     * - base: xsd:token
     * - length: 1
     * - minOccurs: 0
     * @var string
     */
    public $ThirdPlaceholderID;
    /**
     * The FourthPlaceholderID
     * Meta information extracted from the WSDL
     * - documentation: Identifier
     * - base: xsd:token
     * - length: 1
     * - minOccurs: 0
     * @var string
     */
    public $FourthPlaceholderID;
    /**
     * The FirstPlaceholderSubstitutionText
     * Meta information extracted from the WSDL
     * - documentation: Text
     * - base: xsd:string
     * - maxLength: 50
     * - minLength: 1
     * @var string
     */
    public $FirstPlaceholderSubstitutionText;
    /**
     * The SecondPlaceholderSubstitutionText
     * Meta information extracted from the WSDL
     * - documentation: Text
     * - base: xsd:string
     * - maxLength: 50
     * - minLength: 1
     * - minOccurs: 0
     * @var string
     */
    public $SecondPlaceholderSubstitutionText;
    /**
     * The ThirdPlaceholderSubstitutionText
     * Meta information extracted from the WSDL
     * - documentation: Text
     * - base: xsd:string
     * - maxLength: 50
     * - minLength: 1
     * - minOccurs: 0
     * @var string
     */
    public $ThirdPlaceholderSubstitutionText;
    /**
     * The FourthPlaceholderSubstitutionText
     * Meta information extracted from the WSDL
     * - documentation: Text
     * - base: xsd:string
     * - maxLength: 50
     * - minLength: 1
     * - minOccurs: 0
     * @var string
     */
    public $FourthPlaceholderSubstitutionText;
    /**
     * Constructor method for LogItemNotePlaceholderSubstitutionList
     * @uses LogItemNotePlaceholderSubstitutionList::setFirstPlaceholderID()
     * @uses LogItemNotePlaceholderSubstitutionList::setSecondPlaceholderID()
     * @uses LogItemNotePlaceholderSubstitutionList::setThirdPlaceholderID()
     * @uses LogItemNotePlaceholderSubstitutionList::setFourthPlaceholderID()
     * @uses LogItemNotePlaceholderSubstitutionList::setFirstPlaceholderSubstitutionText()
     * @uses LogItemNotePlaceholderSubstitutionList::setSecondPlaceholderSubstitutionText()
     * @uses LogItemNotePlaceholderSubstitutionList::setThirdPlaceholderSubstitutionText()
     * @uses LogItemNotePlaceholderSubstitutionList::setFourthPlaceholderSubstitutionText()
     * @param string $firstPlaceholderID
     * @param string $secondPlaceholderID
     * @param string $thirdPlaceholderID
     * @param string $fourthPlaceholderID
     * @param string $firstPlaceholderSubstitutionText
     * @param string $secondPlaceholderSubstitutionText
     * @param string $thirdPlaceholderSubstitutionText
     * @param string $fourthPlaceholderSubstitutionText
     */
    public function __construct($firstPlaceholderID = null, $secondPlaceholderID = null, $thirdPlaceholderID = null, $fourthPlaceholderID = null, $firstPlaceholderSubstitutionText = null, $secondPlaceholderSubstitutionText = null, $thirdPlaceholderSubstitutionText = null, $fourthPlaceholderSubstitutionText = null)
    {
        $this
            ->setFirstPlaceholderID($firstPlaceholderID)
            ->setSecondPlaceholderID($secondPlaceholderID)
            ->setThirdPlaceholderID($thirdPlaceholderID)
            ->setFourthPlaceholderID($fourthPlaceholderID)
            ->setFirstPlaceholderSubstitutionText($firstPlaceholderSubstitutionText)
            ->setSecondPlaceholderSubstitutionText($secondPlaceholderSubstitutionText)
            ->setThirdPlaceholderSubstitutionText($thirdPlaceholderSubstitutionText)
            ->setFourthPlaceholderSubstitutionText($fourthPlaceholderSubstitutionText);
    }
    /**
     * Get FirstPlaceholderID value
     * @return string|null
     */
    public function getFirstPlaceholderID()
    {
        return $this->FirstPlaceholderID;
    }
    /**
     * Set FirstPlaceholderID value
     * @param string $firstPlaceholderID
     * @return \StructType\LogItemNotePlaceholderSubstitutionList
     */
    public function setFirstPlaceholderID($firstPlaceholderID = null)
    {
        // validation for constraint: string
        if (!is_null($firstPlaceholderID) && !is_string($firstPlaceholderID)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($firstPlaceholderID, true), gettype($firstPlaceholderID)), __LINE__);
        }
        // validation for constraint: length(1)
        if (!is_null($firstPlaceholderID) && mb_strlen($firstPlaceholderID) !== 1) {
            throw new \InvalidArgumentException(sprintf('Invalid length of %s, the number of characters/octets contained by the literal must be equal to 1', mb_strlen($firstPlaceholderID)), __LINE__);
        }
        $this->FirstPlaceholderID = $firstPlaceholderID;
        return $this;
    }
    /**
     * Get SecondPlaceholderID value
     * @return string|null
     */
    public function getSecondPlaceholderID()
    {
        return $this->SecondPlaceholderID;
    }
    /**
     * Set SecondPlaceholderID value
     * @param string $secondPlaceholderID
     * @return \StructType\LogItemNotePlaceholderSubstitutionList
     */
    public function setSecondPlaceholderID($secondPlaceholderID = null)
    {
        // validation for constraint: string
        if (!is_null($secondPlaceholderID) && !is_string($secondPlaceholderID)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($secondPlaceholderID, true), gettype($secondPlaceholderID)), __LINE__);
        }
        // validation for constraint: length(1)
        if (!is_null($secondPlaceholderID) && mb_strlen($secondPlaceholderID) !== 1) {
            throw new \InvalidArgumentException(sprintf('Invalid length of %s, the number of characters/octets contained by the literal must be equal to 1', mb_strlen($secondPlaceholderID)), __LINE__);
        }
        $this->SecondPlaceholderID = $secondPlaceholderID;
        return $this;
    }
    /**
     * Get ThirdPlaceholderID value
     * @return string|null
     */
    public function getThirdPlaceholderID()
    {
        return $this->ThirdPlaceholderID;
    }
    /**
     * Set ThirdPlaceholderID value
     * @param string $thirdPlaceholderID
     * @return \StructType\LogItemNotePlaceholderSubstitutionList
     */
    public function setThirdPlaceholderID($thirdPlaceholderID = null)
    {
        // validation for constraint: string
        if (!is_null($thirdPlaceholderID) && !is_string($thirdPlaceholderID)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($thirdPlaceholderID, true), gettype($thirdPlaceholderID)), __LINE__);
        }
        // validation for constraint: length(1)
        if (!is_null($thirdPlaceholderID) && mb_strlen($thirdPlaceholderID) !== 1) {
            throw new \InvalidArgumentException(sprintf('Invalid length of %s, the number of characters/octets contained by the literal must be equal to 1', mb_strlen($thirdPlaceholderID)), __LINE__);
        }
        $this->ThirdPlaceholderID = $thirdPlaceholderID;
        return $this;
    }
    /**
     * Get FourthPlaceholderID value
     * @return string|null
     */
    public function getFourthPlaceholderID()
    {
        return $this->FourthPlaceholderID;
    }
    /**
     * Set FourthPlaceholderID value
     * @param string $fourthPlaceholderID
     * @return \StructType\LogItemNotePlaceholderSubstitutionList
     */
    public function setFourthPlaceholderID($fourthPlaceholderID = null)
    {
        // validation for constraint: string
        if (!is_null($fourthPlaceholderID) && !is_string($fourthPlaceholderID)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($fourthPlaceholderID, true), gettype($fourthPlaceholderID)), __LINE__);
        }
        // validation for constraint: length(1)
        if (!is_null($fourthPlaceholderID) && mb_strlen($fourthPlaceholderID) !== 1) {
            throw new \InvalidArgumentException(sprintf('Invalid length of %s, the number of characters/octets contained by the literal must be equal to 1', mb_strlen($fourthPlaceholderID)), __LINE__);
        }
        $this->FourthPlaceholderID = $fourthPlaceholderID;
        return $this;
    }
    /**
     * Get FirstPlaceholderSubstitutionText value
     * @return string|null
     */
    public function getFirstPlaceholderSubstitutionText()
    {
        return $this->FirstPlaceholderSubstitutionText;
    }
    /**
     * Set FirstPlaceholderSubstitutionText value
     * @param string $firstPlaceholderSubstitutionText
     * @return \StructType\LogItemNotePlaceholderSubstitutionList
     */
    public function setFirstPlaceholderSubstitutionText($firstPlaceholderSubstitutionText = null)
    {
        // validation for constraint: string
        if (!is_null($firstPlaceholderSubstitutionText) && !is_string($firstPlaceholderSubstitutionText)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($firstPlaceholderSubstitutionText, true), gettype($firstPlaceholderSubstitutionText)), __LINE__);
        }
        // validation for constraint: maxLength(50)
        if (!is_null($firstPlaceholderSubstitutionText) && mb_strlen($firstPlaceholderSubstitutionText) > 50) {
            throw new \InvalidArgumentException(sprintf('Invalid length of %s, the number of characters/octets contained by the literal must be less than or equal to 50', mb_strlen($firstPlaceholderSubstitutionText)), __LINE__);
        }
        // validation for constraint: minLength(1)
        if (!is_null($firstPlaceholderSubstitutionText) && mb_strlen($firstPlaceholderSubstitutionText) < 1) {
            throw new \InvalidArgumentException(sprintf('Invalid length of %s, the number of characters/octets contained by the literal must be greater than or equal to 1', mb_strlen($firstPlaceholderSubstitutionText)), __LINE__);
        }
        $this->FirstPlaceholderSubstitutionText = $firstPlaceholderSubstitutionText;
        return $this;
    }
    /**
     * Get SecondPlaceholderSubstitutionText value
     * @return string|null
     */
    public function getSecondPlaceholderSubstitutionText()
    {
        return $this->SecondPlaceholderSubstitutionText;
    }
    /**
     * Set SecondPlaceholderSubstitutionText value
     * @param string $secondPlaceholderSubstitutionText
     * @return \StructType\LogItemNotePlaceholderSubstitutionList
     */
    public function setSecondPlaceholderSubstitutionText($secondPlaceholderSubstitutionText = null)
    {
        // validation for constraint: string
        if (!is_null($secondPlaceholderSubstitutionText) && !is_string($secondPlaceholderSubstitutionText)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($secondPlaceholderSubstitutionText, true), gettype($secondPlaceholderSubstitutionText)), __LINE__);
        }
        // validation for constraint: maxLength(50)
        if (!is_null($secondPlaceholderSubstitutionText) && mb_strlen($secondPlaceholderSubstitutionText) > 50) {
            throw new \InvalidArgumentException(sprintf('Invalid length of %s, the number of characters/octets contained by the literal must be less than or equal to 50', mb_strlen($secondPlaceholderSubstitutionText)), __LINE__);
        }
        // validation for constraint: minLength(1)
        if (!is_null($secondPlaceholderSubstitutionText) && mb_strlen($secondPlaceholderSubstitutionText) < 1) {
            throw new \InvalidArgumentException(sprintf('Invalid length of %s, the number of characters/octets contained by the literal must be greater than or equal to 1', mb_strlen($secondPlaceholderSubstitutionText)), __LINE__);
        }
        $this->SecondPlaceholderSubstitutionText = $secondPlaceholderSubstitutionText;
        return $this;
    }
    /**
     * Get ThirdPlaceholderSubstitutionText value
     * @return string|null
     */
    public function getThirdPlaceholderSubstitutionText()
    {
        return $this->ThirdPlaceholderSubstitutionText;
    }
    /**
     * Set ThirdPlaceholderSubstitutionText value
     * @param string $thirdPlaceholderSubstitutionText
     * @return \StructType\LogItemNotePlaceholderSubstitutionList
     */
    public function setThirdPlaceholderSubstitutionText($thirdPlaceholderSubstitutionText = null)
    {
        // validation for constraint: string
        if (!is_null($thirdPlaceholderSubstitutionText) && !is_string($thirdPlaceholderSubstitutionText)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($thirdPlaceholderSubstitutionText, true), gettype($thirdPlaceholderSubstitutionText)), __LINE__);
        }
        // validation for constraint: maxLength(50)
        if (!is_null($thirdPlaceholderSubstitutionText) && mb_strlen($thirdPlaceholderSubstitutionText) > 50) {
            throw new \InvalidArgumentException(sprintf('Invalid length of %s, the number of characters/octets contained by the literal must be less than or equal to 50', mb_strlen($thirdPlaceholderSubstitutionText)), __LINE__);
        }
        // validation for constraint: minLength(1)
        if (!is_null($thirdPlaceholderSubstitutionText) && mb_strlen($thirdPlaceholderSubstitutionText) < 1) {
            throw new \InvalidArgumentException(sprintf('Invalid length of %s, the number of characters/octets contained by the literal must be greater than or equal to 1', mb_strlen($thirdPlaceholderSubstitutionText)), __LINE__);
        }
        $this->ThirdPlaceholderSubstitutionText = $thirdPlaceholderSubstitutionText;
        return $this;
    }
    /**
     * Get FourthPlaceholderSubstitutionText value
     * @return string|null
     */
    public function getFourthPlaceholderSubstitutionText()
    {
        return $this->FourthPlaceholderSubstitutionText;
    }
    /**
     * Set FourthPlaceholderSubstitutionText value
     * @param string $fourthPlaceholderSubstitutionText
     * @return \StructType\LogItemNotePlaceholderSubstitutionList
     */
    public function setFourthPlaceholderSubstitutionText($fourthPlaceholderSubstitutionText = null)
    {
        // validation for constraint: string
        if (!is_null($fourthPlaceholderSubstitutionText) && !is_string($fourthPlaceholderSubstitutionText)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($fourthPlaceholderSubstitutionText, true), gettype($fourthPlaceholderSubstitutionText)), __LINE__);
        }
        // validation for constraint: maxLength(50)
        if (!is_null($fourthPlaceholderSubstitutionText) && mb_strlen($fourthPlaceholderSubstitutionText) > 50) {
            throw new \InvalidArgumentException(sprintf('Invalid length of %s, the number of characters/octets contained by the literal must be less than or equal to 50', mb_strlen($fourthPlaceholderSubstitutionText)), __LINE__);
        }
        // validation for constraint: minLength(1)
        if (!is_null($fourthPlaceholderSubstitutionText) && mb_strlen($fourthPlaceholderSubstitutionText) < 1) {
            throw new \InvalidArgumentException(sprintf('Invalid length of %s, the number of characters/octets contained by the literal must be greater than or equal to 1', mb_strlen($fourthPlaceholderSubstitutionText)), __LINE__);
        }
        $this->FourthPlaceholderSubstitutionText = $fourthPlaceholderSubstitutionText;
        return $this;
    }
}
