<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for NielsenRegionCode StructType
 * Meta information extracted from the WSDL
 * - documentation: Code
 * - base: xsd:token
 * - maxLength: 2
 * - minLength: 1
 * @subpackage Structs
 */
class NielsenRegionCode extends AbstractStructBase
{
    /**
     * The _
     * Meta information extracted from the WSDL
     * - base: xsd:token
     * - maxLength: 2
     * - minLength: 1
     * @var string
     */
    public $_;
    /**
     * The listID
     * Meta information extracted from the WSDL
     * - base: xsd:token
     * - maxLength: 60
     * - minLength: 1
     * @var string
     */
    public $listID;
    /**
     * The listAgencyID
     * Meta information extracted from the WSDL
     * - base: xsd:token
     * - maxLength: 60
     * - minLength: 1
     * @var string
     */
    public $listAgencyID;
    /**
     * Constructor method for NielsenRegionCode
     * @uses NielsenRegionCode::set_()
     * @uses NielsenRegionCode::setListID()
     * @uses NielsenRegionCode::setListAgencyID()
     * @param string $_
     * @param string $listID
     * @param string $listAgencyID
     */
    public function __construct($_ = null, $listID = null, $listAgencyID = null)
    {
        $this
            ->set_($_)
            ->setListID($listID)
            ->setListAgencyID($listAgencyID);
    }
    /**
     * Get _ value
     * @return string|null
     */
    public function get_()
    {
        return $this->_;
    }
    /**
     * Set _ value
     * @param string $_
     * @return \StructType\NielsenRegionCode
     */
    public function set_($_ = null)
    {
        // validation for constraint: string
        if (!is_null($_) && !is_string($_)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($_, true), gettype($_)), __LINE__);
        }
        // validation for constraint: maxLength(2)
        if (!is_null($_) && mb_strlen($_) > 2) {
            throw new \InvalidArgumentException(sprintf('Invalid length of %s, the number of characters/octets contained by the literal must be less than or equal to 2', mb_strlen($_)), __LINE__);
        }
        // validation for constraint: minLength(1)
        if (!is_null($_) && mb_strlen($_) < 1) {
            throw new \InvalidArgumentException(sprintf('Invalid length of %s, the number of characters/octets contained by the literal must be greater than or equal to 1', mb_strlen($_)), __LINE__);
        }
        $this->_ = $_;
        return $this;
    }
    /**
     * Get listID value
     * @return string|null
     */
    public function getListID()
    {
        return $this->listID;
    }
    /**
     * Set listID value
     * @param string $listID
     * @return \StructType\NielsenRegionCode
     */
    public function setListID($listID = null)
    {
        // validation for constraint: string
        if (!is_null($listID) && !is_string($listID)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($listID, true), gettype($listID)), __LINE__);
        }
        // validation for constraint: maxLength(60)
        if (!is_null($listID) && mb_strlen($listID) > 60) {
            throw new \InvalidArgumentException(sprintf('Invalid length of %s, the number of characters/octets contained by the literal must be less than or equal to 60', mb_strlen($listID)), __LINE__);
        }
        // validation for constraint: minLength(1)
        if (!is_null($listID) && mb_strlen($listID) < 1) {
            throw new \InvalidArgumentException(sprintf('Invalid length of %s, the number of characters/octets contained by the literal must be greater than or equal to 1', mb_strlen($listID)), __LINE__);
        }
        $this->listID = $listID;
        return $this;
    }
    /**
     * Get listAgencyID value
     * @return string|null
     */
    public function getListAgencyID()
    {
        return $this->listAgencyID;
    }
    /**
     * Set listAgencyID value
     * @param string $listAgencyID
     * @return \StructType\NielsenRegionCode
     */
    public function setListAgencyID($listAgencyID = null)
    {
        // validation for constraint: string
        if (!is_null($listAgencyID) && !is_string($listAgencyID)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($listAgencyID, true), gettype($listAgencyID)), __LINE__);
        }
        // validation for constraint: maxLength(60)
        if (!is_null($listAgencyID) && mb_strlen($listAgencyID) > 60) {
            throw new \InvalidArgumentException(sprintf('Invalid length of %s, the number of characters/octets contained by the literal must be less than or equal to 60', mb_strlen($listAgencyID)), __LINE__);
        }
        // validation for constraint: minLength(1)
        if (!is_null($listAgencyID) && mb_strlen($listAgencyID) < 1) {
            throw new \InvalidArgumentException(sprintf('Invalid length of %s, the number of characters/octets contained by the literal must be greater than or equal to 1', mb_strlen($listAgencyID)), __LINE__);
        }
        $this->listAgencyID = $listAgencyID;
        return $this;
    }
}
