<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for WeekdaySelection StructType
 * @subpackage Structs
 */
class WeekdaySelection extends AbstractStructBase
{
    /**
     * The MondayIndicator
     * Meta information extracted from the WSDL
     * - documentation: Indicator
     * - base: xsd:boolean
     * - minOccurs: 0
     * @var bool
     */
    public $MondayIndicator;
    /**
     * The TuesdayIndicator
     * Meta information extracted from the WSDL
     * - documentation: Indicator
     * - base: xsd:boolean
     * - minOccurs: 0
     * @var bool
     */
    public $TuesdayIndicator;
    /**
     * The WednesdayIndicator
     * Meta information extracted from the WSDL
     * - documentation: Indicator
     * - base: xsd:boolean
     * - minOccurs: 0
     * @var bool
     */
    public $WednesdayIndicator;
    /**
     * The ThursdayIndicator
     * Meta information extracted from the WSDL
     * - documentation: Indicator
     * - base: xsd:boolean
     * - minOccurs: 0
     * @var bool
     */
    public $ThursdayIndicator;
    /**
     * The FridayIndicator
     * Meta information extracted from the WSDL
     * - documentation: Indicator
     * - base: xsd:boolean
     * - minOccurs: 0
     * @var bool
     */
    public $FridayIndicator;
    /**
     * The SaturdayIndicator
     * Meta information extracted from the WSDL
     * - documentation: Indicator
     * - base: xsd:boolean
     * - minOccurs: 0
     * @var bool
     */
    public $SaturdayIndicator;
    /**
     * The SundayIndicator
     * Meta information extracted from the WSDL
     * - documentation: Indicator
     * - base: xsd:boolean
     * - minOccurs: 0
     * @var bool
     */
    public $SundayIndicator;
    /**
     * Constructor method for WeekdaySelection
     * @uses WeekdaySelection::setMondayIndicator()
     * @uses WeekdaySelection::setTuesdayIndicator()
     * @uses WeekdaySelection::setWednesdayIndicator()
     * @uses WeekdaySelection::setThursdayIndicator()
     * @uses WeekdaySelection::setFridayIndicator()
     * @uses WeekdaySelection::setSaturdayIndicator()
     * @uses WeekdaySelection::setSundayIndicator()
     * @param bool $mondayIndicator
     * @param bool $tuesdayIndicator
     * @param bool $wednesdayIndicator
     * @param bool $thursdayIndicator
     * @param bool $fridayIndicator
     * @param bool $saturdayIndicator
     * @param bool $sundayIndicator
     */
    public function __construct($mondayIndicator = null, $tuesdayIndicator = null, $wednesdayIndicator = null, $thursdayIndicator = null, $fridayIndicator = null, $saturdayIndicator = null, $sundayIndicator = null)
    {
        $this
            ->setMondayIndicator($mondayIndicator)
            ->setTuesdayIndicator($tuesdayIndicator)
            ->setWednesdayIndicator($wednesdayIndicator)
            ->setThursdayIndicator($thursdayIndicator)
            ->setFridayIndicator($fridayIndicator)
            ->setSaturdayIndicator($saturdayIndicator)
            ->setSundayIndicator($sundayIndicator);
    }
    /**
     * Get MondayIndicator value
     * @return bool|null
     */
    public function getMondayIndicator()
    {
        return $this->MondayIndicator;
    }
    /**
     * Set MondayIndicator value
     * @param bool $mondayIndicator
     * @return \StructType\WeekdaySelection
     */
    public function setMondayIndicator($mondayIndicator = null)
    {
        // validation for constraint: boolean
        if (!is_null($mondayIndicator) && !is_bool($mondayIndicator)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($mondayIndicator, true), gettype($mondayIndicator)), __LINE__);
        }
        $this->MondayIndicator = $mondayIndicator;
        return $this;
    }
    /**
     * Get TuesdayIndicator value
     * @return bool|null
     */
    public function getTuesdayIndicator()
    {
        return $this->TuesdayIndicator;
    }
    /**
     * Set TuesdayIndicator value
     * @param bool $tuesdayIndicator
     * @return \StructType\WeekdaySelection
     */
    public function setTuesdayIndicator($tuesdayIndicator = null)
    {
        // validation for constraint: boolean
        if (!is_null($tuesdayIndicator) && !is_bool($tuesdayIndicator)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($tuesdayIndicator, true), gettype($tuesdayIndicator)), __LINE__);
        }
        $this->TuesdayIndicator = $tuesdayIndicator;
        return $this;
    }
    /**
     * Get WednesdayIndicator value
     * @return bool|null
     */
    public function getWednesdayIndicator()
    {
        return $this->WednesdayIndicator;
    }
    /**
     * Set WednesdayIndicator value
     * @param bool $wednesdayIndicator
     * @return \StructType\WeekdaySelection
     */
    public function setWednesdayIndicator($wednesdayIndicator = null)
    {
        // validation for constraint: boolean
        if (!is_null($wednesdayIndicator) && !is_bool($wednesdayIndicator)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($wednesdayIndicator, true), gettype($wednesdayIndicator)), __LINE__);
        }
        $this->WednesdayIndicator = $wednesdayIndicator;
        return $this;
    }
    /**
     * Get ThursdayIndicator value
     * @return bool|null
     */
    public function getThursdayIndicator()
    {
        return $this->ThursdayIndicator;
    }
    /**
     * Set ThursdayIndicator value
     * @param bool $thursdayIndicator
     * @return \StructType\WeekdaySelection
     */
    public function setThursdayIndicator($thursdayIndicator = null)
    {
        // validation for constraint: boolean
        if (!is_null($thursdayIndicator) && !is_bool($thursdayIndicator)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($thursdayIndicator, true), gettype($thursdayIndicator)), __LINE__);
        }
        $this->ThursdayIndicator = $thursdayIndicator;
        return $this;
    }
    /**
     * Get FridayIndicator value
     * @return bool|null
     */
    public function getFridayIndicator()
    {
        return $this->FridayIndicator;
    }
    /**
     * Set FridayIndicator value
     * @param bool $fridayIndicator
     * @return \StructType\WeekdaySelection
     */
    public function setFridayIndicator($fridayIndicator = null)
    {
        // validation for constraint: boolean
        if (!is_null($fridayIndicator) && !is_bool($fridayIndicator)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($fridayIndicator, true), gettype($fridayIndicator)), __LINE__);
        }
        $this->FridayIndicator = $fridayIndicator;
        return $this;
    }
    /**
     * Get SaturdayIndicator value
     * @return bool|null
     */
    public function getSaturdayIndicator()
    {
        return $this->SaturdayIndicator;
    }
    /**
     * Set SaturdayIndicator value
     * @param bool $saturdayIndicator
     * @return \StructType\WeekdaySelection
     */
    public function setSaturdayIndicator($saturdayIndicator = null)
    {
        // validation for constraint: boolean
        if (!is_null($saturdayIndicator) && !is_bool($saturdayIndicator)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($saturdayIndicator, true), gettype($saturdayIndicator)), __LINE__);
        }
        $this->SaturdayIndicator = $saturdayIndicator;
        return $this;
    }
    /**
     * Get SundayIndicator value
     * @return bool|null
     */
    public function getSundayIndicator()
    {
        return $this->SundayIndicator;
    }
    /**
     * Set SundayIndicator value
     * @param bool $sundayIndicator
     * @return \StructType\WeekdaySelection
     */
    public function setSundayIndicator($sundayIndicator = null)
    {
        // validation for constraint: boolean
        if (!is_null($sundayIndicator) && !is_bool($sundayIndicator)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($sundayIndicator, true), gettype($sundayIndicator)), __LINE__);
        }
        $this->SundayIndicator = $sundayIndicator;
        return $this;
    }
}
